<?php

namespace App\Controllers;

use App\Models\AccountModel;
use App\Models\MemberModel;
use App\Models\TLogCashModel;
use App\Models\TGameConfigModel;
use App\Util\CodeUtil;
use App\Util\Casino;
use Cassandra\Date;
use CodeIgniter\API\ResponseTrait;
use App\Models\TProductIdManager;
use App\Models\TProductGroupManager;
use App\Models\TSTTSwitchManager;
use App\Models\TGameIdManager;
use App\Models\GameFavoriteModel;
use App\Models\GamePlayedModel;
use App\Game\Slotbank;
use App\Game\Kplay;
use App\Game\Goodgaming;


class CasinoSwitchingController extends MemberOnlyBaseController  {
    use ResponseTrait;

    public function __construct()
    {
        parent::__construct("CasinoController", false);
    }
    public function index() {
        $chkMobile = CodeUtil::rtn_mobile_chk();
        $viewRoot = "PC" == $chkMobile ? 'web' : 'web';
        $memberIdx = session()->get('member_idx');
        
        if (false == session()->has('member_idx')) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }

        $memberModel = new MemberModel();
        $member = $memberModel->getMemberWhereIdx(session()->get('member_idx'));
        if (!isset($member) || null == $member) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }
        
        if (0 < session()->get('tm_unread_cnt')) {
            $url = base_url("/web/note");
            echo "<script>
            alert('미확인 쪽지를 확인해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }
        
        $tgcModel = new TGameConfigModel();
        $str_sql_config = "SELECT set_type, set_type_val FROM t_game_config WHERE set_type IN('service_site','service_casino','service_slot')";
        $arr_config_result = $tgcModel->db->query($str_sql_config)->getResultArray();

        $arr_config = array();
        foreach ($arr_config_result as $key => $value) {
            $arr_config[$value['set_type']] = $value['set_type_val'];
        }
        
        if ('Y' == $arr_config['service_casino'] && 9 != $member->getLevel()) {
            echo "<script>
            alert('카지노 점검중입니다.');
            window.history.back();
            </script>";
            return;
        }
        
        // 유저개인 점검
        $game_type_sql = "SELECT game_type, status FROM member_game_type where member_idx = ? and game_type in (9)";
        $arr_member_config_result = $tgcModel->db->query($game_type_sql, [$memberIdx])->getResultArray();

        $arr_member_config = array();
        foreach ($arr_member_config_result as $key => $value) {
            $arr_member_config[$value['game_type']]['status'] = $value['status'];
        }

        if ('OFF' == $arr_member_config[9]['status'] && 9 != $member->getLevel()) {
            echo "<script>
            alert('해당 게임 배팅이 금지되어있습니다.');
            window.history.back();
            </script>";
            return;
        }
        
        $tb_static_product_group_manager = new TProductGroupManager();
        $first_casino = $tb_static_product_group_manager->getFirst(1);
        if($first_casino["provider_id"] == CONSTANTS_KPLAY) {
            $product_list = $tb_static_product_group_manager->getProductListByTypeProvider(1, $first_casino["provider_id"]);
        }   
        else {
            $_product_list = $tb_static_product_group_manager->getProductListByTypeProviderV2(1, $first_casino["provider_id"]);
            $product_list = [];

            if($first_casino["provider_id"] == CONSTANTS_SLOTBANK) {
                foreach($_product_list as $product) {
                    if(isset($product["slotbank_id"])) {
                        $product_list[] = $product;
                    }
                }
            }
            
            if($first_casino["provider_id"] == CONSTANTS_GOODGAMING) {
                foreach($_product_list as $product) {
                    if(isset($product["good_gaming_id"])) {
                        $product_list[] = $product;
                    }
                }
            }
            
        }
        $view_data["product_list"] = $product_list;
        
        return view("$viewRoot/casino_list_switching", $view_data);
    }

    public function index_slot() {
        $this->redirectNotLoggedInUsers();
        $memberModel = new MemberModel();
        $chkMobile = CodeUtil::rtn_mobile_chk();
        $viewRoot = "PC" == $chkMobile ? 'web' : 'web';

        if (false == session()->has('member_idx')) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }

        $member = $memberModel->getMemberWhereIdx(session()->get('member_idx'));
        if (!isset($member) || null == $member) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }

        $tgcModel = new TGameConfigModel();
        //$config = $tgcModel->getMemberMaxBetMoney(1, $member->getLevel());
        //$arr_config = $this->gmPt->getConfigData($tgcModel);
        $str_sql_config = "SELECT set_type, set_type_val FROM t_game_config WHERE set_type IN('service_site','service_casino','service_slot')";
        $arr_config_result = $tgcModel->db->query($str_sql_config)->getResultArray();

        $arr_config = array();
        foreach ($arr_config_result as $key => $value) {
            $arr_config[$value['set_type']] = $value['set_type_val'];
        }
        
        if ('Y' == $arr_config['service_casino'] && 9 != $member->getLevel()) {
            echo "<script>
            alert('슬롯 점검중입니다.');
            window.history.back();
            </script>";
            return;
        }

        $tb_static_product_group_manager = new TProductGroupManager();
        $product_list = $tb_static_product_group_manager->getProductListByType(2);
        $provider_id = null;

        $view_data["product_list"] = $product_list;

        if($product_list[0]["provider_id"] != 1) {
            return view("$viewRoot/slot", $view_data);
        }
        else {
            return view("$viewRoot/slot_lobby", $view_data);
        }

    }

    public function viewGameResult() {
        $slotbank = new SlotBank($this->logger);
        $goodgaming = new Goodgaming($this->logger);
        $round_id = $_POST["m_idx"];
        $result_url = $slotbank->getRoundResult($round_id);

        if(!$result_url) {
            $result_url = $goodgaming->getRoundResult($_POST["m_idx"]);
        }

        header('Location: '. $result_url);
    }

    public function enter() {
        $tb_member = new MemberModel();
        $tb_static_product_group_manager = new TProductGroupManager();
        $chkMobile = CodeUtil::rtn_mobile_chk();
        $member_idx = session()->get('member_idx');
        $member_info = $tb_member->where('idx', $member_idx)->first();
        $product_group_id = isset($_REQUEST['product_group_id']) ? $_REQUEST['product_group_id'] : 1;
        $game_id = isset($_REQUEST['game_id']) ? $_REQUEST['game_id'] : 0;

        /* get product information */
        $product_group_info = $tb_static_product_group_manager->getProductInformation($product_group_id);
        $provider_id = $product_group_info["provider_id"];

        switch ($provider_id) {
            case CONSTANTS_GOODGAMING: //goodgaming
                $game_model = new Goodgaming($this->logger);
                $game_url = $game_model->getGameURL($member_info, $product_group_info, $game_id);
                if($game_url['code'] != 200){
                    return $this->fail($game_url, 400);
                }
                break;
            case CONSTANTS_SLOTBANK: //slotbank
                $game_model = new Slotbank($this->logger);
                $game_url = $game_model->getGameURL($member_info, $product_group_info, $game_id);
                $this->logger->info("test : ".json_encode($game_url));
                if($game_url['result'] != 1){
                    return $this->fail($game_url, 400);
                }
                break;

            case CONSTANTS_KPLAY: //kplay
                
                $product_type_id = isset($_REQUEST['product_type_id']) ? $_REQUEST['product_type_id'] : 1;
                
                $apiUrl = config(App::class)->ApiUrl;
                $agToken = config(App::class)->AgToken;
                $agCode = config(App::class)->AgCode;
                $sercetKey = config(App::class)->SercetKey;
                $game_model = new Kplay($apiUrl, $agToken, $agCode, $sercetKey, $this->logger);

                $domain_url = substr(config(App::class)->baseURL, 0, -1);
                $type = $game_id;
                $is_mobile = "PC" == $chkMobile ? 0 : 1;

                $sql = "select product_id from tb_static_product_id_manager where product_group_id = ? and product_type_id = ? and provider_id = 1";
                $prd_data = $tb_member->db->query($sql, [$_REQUEST['product_group_id'], $product_type_id])->getResultArray();

                $prd_id = isset($_REQUEST['product_id']) ? $_REQUEST['product_id'] : $prd_data[0]['product_id'];
                if (!$prd_data) {
                    $game_model->returnError('empty data');
                } else {
                    $result = $game_model->auth($member_idx, $member_info->getId(), $member_info->getMoney(), $domain_url, $prd_id,$type, $is_mobile);
                    if ($result->status == 0) {
                        $game_model->returnError($result->error);
                    } else {
                        $sql = "SELECT count(*) as cnt FROM KP_MBR_INF WHERE KP_ID = $result->user_id";
                        $mbrinf = $tb_member->db->query($sql)->getResultArray();
                        if ($mbrinf[0]['cnt'] == 0) {
                            $sql = "INSERT INTO KP_MBR_INF(MBR_IDX, KP_ID, KP_NM, REG_DTM) VALUES(?,?,?, now())";
                            $tb_member->db->query($sql, [$member_idx, $result->user_id, $result->username]);
                        }

                        $game_url = $result->launch_url;
                    }
                }
                break;
        }

        /* check for error */
        if ($game_model->is_error) {
            return $this->fail($game_model->message, 400);
        } else {
            $game_played_model = new GamePlayedModel();
            $game_list_model = new TGameIdManager();
            $game_list_model->increasePopularityCount($game_id, 1);
            $game_played_model->setAsRecentlyPlayed($game_id, $member_idx);

            if(isset($_GET["product_group_id"])) {
                if(CONSTANTS_KPLAY == $provider_id){
                    if($product_type_id == 2){
                       echo $game_url;
                    }else{
                        header('Location: '.$game_url);

                    }

                }else if(CONSTANTS_GOODGAMING == $provider_id) {
                    if($product_type_id == 2){
                        header('Location: '.$game_url);
                    } else {
                        header('Location: '.$game_url['link']);
                    }
                }else{
                    header('Location: '.$game_url["data"]["link"]);
                }
            }else {
                return $this->respond($game_url, 200);
            }
        }
    }
    public function callback() {
        /* initialized parameters / 초기화된 매개변수 */
        $uri = current_url(true);
        $provider_name = $uri->getSegment(3);
        $function_name = $uri->getSegment(4);
        $response = ['status' => 400, 'message' => 'Default Response'];

        /* show log / 로그 표시 */
        $this->logger->info(':: CasinoController: callback(' . $provider_name . ', ' . $function_name . ') ');

        /* get information / 정보를 얻다 */
        $__rawBody = file_get_contents("php://input"); // 본문을 불러옴
        $__getData = json_decode($__rawBody, true);
        $casinoObj = null;

        $this->logger->info('');
        $this->logger->info('');
        $this->logger->info(':::: START CALLBACK :::::');

        /* switch provider / 스위치 공급자 */
        switch ($provider_name) {
            case 'kplay':
                $casinoObj = new Kplay(config(App::class)->ApiUrl, config(App::class)->AgToken, config(App::class)->AgCode, config(App::class)->SercetKey, $this->logger);
                break;
            case 'slotbank':
                $casinoObj = new SlotBank($this->logger);
                break;
            case 'goodgaming':
                $casinoObj = new Goodgaming($this->logger);
                break;

            default:
                die("Not Supported");
                break;
        }

        /* construct error response if no data has been returned / 데이터가 반환되지 않은 경우 오류 응답 구성 */
        if (null == $casinoObj) {
            $response = ['status' => 0, 'error' => 'UNKNOWN_ERROR'];
            $this->logger->error(':: CasinoController: response : ' . json_encode($response, JSON_UNESCAPED_UNICODE));
            $this->logger->error(':: CasinoController: fail provider_name : ' . $provider_name);
            return;
        }

        /* start transaction / 거래 시작  */
        $memberModel = new MemberModel();

        $memberModel->db->transStart();
        $userId = $__getData['userId'];
        $product_type = 1;
        // $this->logger->info(':: CasinoController: $_POST '. json_encode($_POST));
        /* slotbank data comes from $_POST */
        if ($provider_name == 'slotbank') {
            $userId = $_POST["userid"];
            $__getData = $_POST;
            $this->logger->info(':: CasinoController: Slotbank User ID (' . $userId . ')');
            $product_id = $__getData['third_party_code'];

            $tb_static_product_group_manager = new TProductGroupManager();
            $product_type_id = $tb_static_product_group_manager->where("slotbank_id", $product_id)->first();
            // $this->logger->info(':: CasinoController sb : product_type_id '. json_encode($product_type_id));
            $product_type = $product_type_id["product_type_id"];

        }else if($provider_name == 'kplay'){
            //$_POST = $__getData;
            $userId = $__getData['user_id'];//$_POST["user_id"];
            $this->logger->info(':: CasinoController: kplay $__getData '. json_encode($__getData));
            $_POST = $__getData;
            $product_id = $__getData['prd_id'];
            $model = new MemberModel();
            $sql = 'select product_type_id from tb_static_product_id_manager where product_id = ? and provider_id = 1';
            $prd = $model->db->query($sql, [$product_id])->getResultArray();
            // $this->logger->info(':: CasinoController kp : prd '. json_encode($prd));
            $product_type = $prd[0];

            //$this->logger->info(':: CasinoController: kplay $_POST '. json_encode($_POST));
            $this->logger->info(':: CasinoController: kplay User ID (' . $userId . ')');
        }else if($provider_name == 'goodgaming'){
            $rawData = file_get_contents('php://input');
            // $this->logger->info($rawData);
            $_PATCH = file_get_contents('php://input');
   
            $__getData = $_GET;

            if(!empty($_PATCH)) {
                $__getData = json_decode($_PATCH, true);
                $this->logger->info("Decoded:");
                $this->logger->info($__getData);
            }
            
            $userId = str_replace("goodgaming", "", $__getData["username"]);
            $product_id = $__getData['vendorCode'];
            $tb_static_product_group_manager = new TProductGroupManager();
        
            $product_group_info = $tb_static_product_group_manager->where("good_gaming_id", $product_id)->first();
            // $this->logger->info(':: CasinoController gg : product_group_info '. json_encode($product_group_info));
            $product_type = $product_group_info["product_type_id"];
            $this->logger->info(':: CasinoController: goodgaming User ID (' . $userId . ')');
        }

        list($member, $message) = $casinoObj->isLoginById($userId, $function_name, $memberModel);

        if (null == $member) {
            $memberModel->db->transRollback();
            $response = ['status' => 0, 'error' => 'INVALID_USER'];
            $this->logger->error('callback response : ' . json_encode($response, JSON_UNESCAPED_UNICODE));
            $this->logger->error('callback error message: ' . $message);
            return json_encode($response, JSON_UNESCAPED_UNICODE);
        }

        if($product_type == 1){
            $checkProduct = LGTB_CASINO;
        } else {
            $checkProduct = LGTB_SLOT;
        }

        if (false == $this->checkServer($member, $checkProduct)[0] && $function_name == "betting") {
            $memberModel->db->transRollback();
            $response = ['status' => 0, 'error' => 'USER_BLOCKING_GAME PRODUCT_TYPE(9 => CASINO , 10 => SLOT) : '.$checkProduct];
            $this->logger->error(':: CasinoController: Callback Response : ' . json_encode($response, JSON_UNESCAPED_UNICODE));
            return json_encode($response, JSON_UNESCAPED_UNICODE);
        }

        list($retCode, $result, $data, $message) = $casinoObj->processRequest($member, $memberModel, $function_name, $__getData, $this->logger);

        if (0 == $retCode) {
            $memberModel->db->transRollback();
            $response = ['status' => $retCode, 'error' => $result];
        } else {
            $memberModel->db->transComplete();
            $response = ['result' => $retCode, 'status' => $retCode, 'balance' => (double) $result, 'payload' => $data, 'message' => $message];
        }

        $this->logger->info($response);
        $this->logger->info(':::: END CALLBACK :::::');

        return json_encode($response, JSON_UNESCAPED_UNICODE);
    }
    public function enterProductType() {
        /* redirect if user is not logged-in / 사용자가 로그인하지 않은 경우 리디렉션 */
        $this->redirectNotLoggedInUsers();

        /* show logs on writable / 쓰기 가능한 로그 표시 */
        $this->logger->info(':: CasinoController: enterProductType() ');

        /* get account of logged-in user and get $_POST information / 로그인한 사용자 계정 가져오기 및 $_POST 정보 가져오기 */
        $member = $this->logged_in_member;
        $_POST = $this->filterSanitize($_POST);
        $product_type_id = isset($_POST['product_type_id']) ? $_POST['product_type_id'] : 0;

        /* check post information / 게시물 정보 확인 */
        if (!CodeUtil::only_number($product_type_id) || 0 == $product_type_id || 10 < $product_type_id) {
            $this->logger->error(':: CasinoController: Product Type ID check Fail : ' . $product_type_id);
            die();
        }

        /* check active provider information / 활성 공급자 정보 확인 */
        $switch_model = new TSTTSwitchManager();
        $enabled_provider = $switch_model->where('tb_static_product_group_manager.product_type_id', $product_type_id)
                ->join('tb_static_provider_manager', 'tb_static_provider_manager.provider_id = tb_static_switch_manager.provider_id')
                ->join('tb_static_product_group_manager', 'tb_static_product_group_manager.product_group_id = tb_static_switch_manager.product_group_id')
                ->first();

        /* check if enabled providers are using lobby / 활성화된 공급자가 로비를 사용하고 있는지 확인 */
        $is_lobby = $enabled_provider["is_lobby"];
        $game_list = null;
        $member_idx = $this->logged_in_member["idx"];

        $result = $switch_model->getCanUseData($product_type_id);

        /* load additional parameters if there is no lobby / 로비가 없는 경우 추가 매개변수 로드 */
        $product_group_id = isset($_POST['product_group_id']) ? $_POST['product_group_id'] : 0;
        $filter_mode = isset($_POST['filter_mode']) ? $_POST['filter_mode'] : null;
        $limit = isset($_POST['limit']) ? $_POST['limit'] : null;
        $skip = isset($_POST['skip']) ? $_POST['skip'] : null;
        $search_val = isset($_POST['search_val']) ? $_POST['search_val'] : null;

        $game_list_model = new TGameIdManager();

        /* show logs on writable / 쓰기 가능한 로그 표시 */
        $this->logger->info(':: CasinoController: getGameList(' . $member_idx . ', ' . $limit . ', ' . $skip . ') ');

        $game_list = $game_list_model->getGameList($member_idx, $enabled_provider["provider_id"], $product_type_id, $product_group_id, $filter_mode, $limit, $skip,$search_val);
        
        // list($retval, $message) = $this->checkServer($member, $product_type_id);
        // if (false == $retval)
        // {
        //     $response['messages'] = $message;
        //     return $this->fail($response);
        // }

        /* return a response / 응답을 반환  */
        $response = ['result_code' => 200, 'data' => $response, 'game_list' => $game_list, 'group_list' => $result];

        return $this->respond($response);
    }

    public function gameUpdateScheduler() {
        $uri = current_url(true);
        $provider_id = $uri->getSegment(3);

        switch ($provider_id) {
            case CONSTANTS_SLOTBANK: //slotbank
                $game_model = new Slotbank($this->logger);
                break;

            case CONSTANTS_KPLAY: //kplay
                $game_model = new Kplay(config(App::class)->ApiUrl, config(App::class)->AgToken, config(App::class)->AgCode, config(App::class)->SercetKey, $this->logger);
                break;

            case CONSTANTS_GOODGAMING: //goodgaming
                $game_model = new Goodgaming($this->logger);
                break;
        }

        return $game_model->fetchAndSaveGameList();
    }

    public function slot() {
        $chkMobile = CodeUtil::rtn_mobile_chk();
        $viewRoot = "PC" == $chkMobile ? 'web' : 'web';
        $memberIdx = session()->get('member_idx');

        if (false == session()->has('member_idx')) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }

        $memberModel = new MemberModel();
        $member = $memberModel->getMemberWhereIdx(session()->get('member_idx'));
        if (!isset($member) || null == $member) {
            $url = base_url("/$viewRoot/index");
            echo "<script>
            alert('로그인 후 이용해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }
        
        if (0 < session()->get('tm_unread_cnt')) {
            $url = base_url("/web/note");
            echo "<script>
            alert('미확인 쪽지를 확인해주세요.');
            window.location.href='$url';
            </script>";
            return;
        }

        $tgcModel = new TGameConfigModel();
        $str_sql_config = "SELECT set_type, set_type_val FROM t_game_config WHERE set_type IN('service_site','service_casino','service_slot')";
        $arr_config_result = $tgcModel->db->query($str_sql_config)->getResultArray();
        
        $arr_config = array();
        foreach ($arr_config_result as $key => $value) {
            $arr_config[$value['set_type']] = $value['set_type_val'];
        }
        
        if ('Y' == $arr_config['service_slot'] && 9 != $member->getLevel()) {
            echo "<script>
            alert('슬롯 점검중입니다.');
            window.history.back();
            </script>";
            return;
        }

        // 유저개인 점검
        $game_type_sql = "SELECT game_type, status FROM member_game_type where member_idx = ? and game_type in (10)";
        $arr_member_config_result = $tgcModel->db->query($game_type_sql, [$memberIdx])->getResultArray();

        $arr_member_config = array();
        foreach ($arr_member_config_result as $key => $value) {
            $arr_member_config[$value['game_type']]['status'] = $value['status'];
        }

        if ('OFF' == $arr_member_config[10]['status'] && 9 != $member->getLevel()) {
            echo "<script>
            alert('해당 게임 배팅이 금지되어있습니다.');
            window.history.back();
            </script>";
            return;
        }
        
        $tb_static_product_group_manager = new TProductGroupManager();
        $product_list = $tb_static_product_group_manager->getProductListByType(2);
        $provider_id = null;

        $view_data["product_list"] = $product_list;
        if($product_list[0]["provider_id"] == 3) {
            return view("$viewRoot/slot", $view_data);
        }
        else {
            return view("$viewRoot/slot_lobby", $view_data);
        }
    }

    public function slotStart() {
        $member_idx = session()->get('member_idx');
        $chkMobile = CodeUtil::rtn_mobile_chk();
        $mobileType = "PC" == $chkMobile ? 'web' : 'web';
        $viewRoot = "PC" == $chkMobile ? 'web' : 'web';

        $uri = new \CodeIgniter\HTTP\URI();
        $uri = service('uri');
        $first = $uri->getSegment(2);
        $second = $uri->getSegment(3);
        return view("$viewRoot/slot_lobby", [
            'mobileType' => $mobileType,
            'productId' => $first,
            'gameId' => $second
        ]);
    }
}
