<?php

namespace App\Controllers;
use App\Models\MemberModel;
use CodeIgniter\API\ResponseTrait;
use CodeIgniter\Log\Logger;

class DataDeleteController extends BaseController {

    use ResponseTrait;
    
    protected $delTime = 3; // 삭제시간
    protected $casino_delTime = 1; // 삭제시간

    // casino bet delete
    public function doDeleteCasinoBetData() {
        $memberModel = new MemberModel();
        
        $sql_delete = 'delete from KP_CSN_BET_HIST where REG_DTM < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->casino_delTime]);
        
        $sql_delete = 'delete from KP_ESPT_BET_HIST where REG_DTM < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->casino_delTime]);
        
        $sql_delete = 'delete from KP_SLOT_BET_HIST where REG_DTM < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->casino_delTime]);
        
        $sql_delete = 'delete from tb_betting_info where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->casino_delTime]);
        
        $sql_delete = 'delete from tb_betting_info_callback where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->casino_delTime]);
        
        $response = [
            'result_code' => 200,
            'messages' => '삭제 성공'
        ];
        return $this->respond($response, 200);
    }

    // sport, realtime bet delete
    public function doDeleteBetData() {
        $memberModel = new MemberModel();
        
        $sql_delete = 'delete from member_bet where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from member_bet_detail where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $response = [
            'result_code' => 200,
            'messages' => '삭제 성공'
        ];
        return $this->respond($response, 200);
    }
    
    // minigame, minigame bet delete
    public function doDeleteMiniBetData() {
        $memberModel = new MemberModel();
        
        $sql_delete = 'delete from mini_game where start_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from mini_game_member_bet where calculate_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $response = [
            'result_code' => 200,
            'messages' => '삭제 성공'
        ];
        return $this->respond($response, 200);
    }
    
    // charge, exchange delete
    public function doDeleteChargeData() {
        $memberModel = new MemberModel();
        
        $sql_delete = 'delete from member_money_charge_history where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from member_money_exchange_history where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $response = [
            'result_code' => 200,
            'messages' => '삭제 성공'
        ];
        return $this->respond($response, 200);
    }

    // charge, exchange delete
    public function doDeleteLogData() {
        $memberModel = new MemberModel();
        
        $sql_delete = 'delete from member_money_charge_sms where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from member_ip_block_history where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from member_login_history where login_datetime < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from menu_qna where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from sms_auth where create_dt < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from t_message where reg_time < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $sql_delete = 'delete from t_message_list where reg_time < date_sub(NOW(),interval ? month)';
        $memberModel->db->query($sql_delete, [$this->delTime]);
        
        $response = [
            'result_code' => 200,
            'messages' => '삭제 성공'
        ];
        return $this->respond($response, 200);
    }
}