<?php
namespace App\Controllers;
use App\Models\MemberModel;

class MemberOnlyBaseController extends BaseController
{
    public $logged_in_member                    = null;
    private $child_controller                   = null;
    private $auto_redirect_not_loggedin_users   = true;

	public function __construct($controller = null, $auto_redirect = true)
	{
        /* store child controller information / 하위 컨트롤러 정보 저장 */
        $this->child_controller                     = $controller;
        $this->auto_redirect_not_loggedin_users     = $auto_redirect;

        /* check if user is currently logged-in and redirect if not */
        $this->checkLoggedIn();
    }
    public function checkLoggedIn()
    {
        /* get member id from session / 세션에서 멤버 ID 가져오기 */
        $member_idx         = session()->get('member_idx');
        
        /* redirect user if not logged-in / 로그인하지 않은 경우 사용자 리디렉션 */
        if (isset($member_idx) && $member_idx)
        {
            /* get member information and store to $logged_in_member so it can be accessed anytime / 언제든지 액세스할 수 있도록 회원 정보를 가져오고 $logged_in_user에 저장합니다. */
            $member_model   = new MemberModel();
            $member         = $member_model->find($member_idx);

            /* redirect user if not logged-in / 로그인하지 않은 경우 사용자 리디렉션 */
            if(isset($member) && $member)
            {
                $this->logged_in_member = $member->toArray();
            }
            else
            {
                if($this->auto_redirect_not_loggedin_users)
                {
                    $this->redirectNotLoggedInUsers();
                }
            }
        }
        else
        {
            if($this->auto_redirect_not_loggedin_users)
            {
                $this->redirectNotLoggedInUsers();
            }
        }
    }
    public function redirectNotLoggedInUsers()
    {
        if(!$this->logged_in_member)
        {
            /* redirect user if not logged-in / 로그인하지 않은 경우 사용자 리디렉션 */
            $url = base_url("/$viewRoot");
            echo "<script>alert('로그인 후 이용해주세요.'); window.location.href='$url'; </script>";
            return;
            header("Location: " . $url);
            die();
        }
    }
}