<?php

namespace App\DistStat;

use App\Models\MainModel;

class DistStat {

    static public function AddCharge($member_idx, $amount, $count, $model) { // 자동충전 안씀
        $sql = "select ifnull(ps.idx,0) as dist_idx from member 
                left join member as ps
                on ps.id = member.dis_id
                where member.idx = ? and ps.u_business <> 1";

        $result = $model->db->query($sql, [$member_idx])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx'])
            return;

        $dist_idx = $result[0]['dist_idx'];
        
        $main_model = new MainModel();

        $sql = "select ifnull(dist_idx,0) as dist_idx from tb_dist_sts_info where dist_idx = ?";

        $result = $main_model->db->query($sql, [$result[0]['dist_idx']])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx']) {
            $sql = "insert into tb_dist_sts_info(dist_idx,day_charge,day_charge_count,month_charge,month_charge_count) value(?,?,?,?,?)";
            $main_model->db->query($sql, [$dist_idx, $amount, $count, $amount, $count]);
        } else {
            $sql = "update tb_dist_sts_info set day_charge = day_charge + ? ,day_charge_count = day_charge_count + ?
                    ,month_charge = month_charge + ? ,month_charge_count = month_charge_count + ? 
                    where dist_idx = ?";
            $main_model->db->query($sql, [$amount, $count, $amount, $count, $dist_idx]);
        }
    }

    static public function AddExchange($member_idx, $amount, $count, $model) {

        $sql = "select ifnull(ps.idx,0) as dist_idx from member 
                left join member as ps
                on ps.id = member.dis_id
                where member.idx = ? and ps.u_business <> 1";

        $result = $model->db->query($sql, [$member_idx])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx'])
            return;

        $dist_idx = $result[0]['dist_idx'];
        $main_model = new MainModel();

        $sql = "select ifnull(dist_idx,0) as dist_idx from tb_dist_sts_info where dist_idx = ?";

        $result = $main_model->db->query($sql, [$result[0]['dist_idx']])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx']) {
            $sql = "insert into tb_dist_sts_info(dist_idx,day_exchange,day_exchange_count,month_exchange,month_exchange_count) value(?,?,?,?,?)";
            $main_model->db->query($sql, [$dist_idx, $amount, $count, $amount, $count]);
        } else {
            $sql = "update tb_dist_sts_info set day_exchange = day_exchange + ? ,day_exchange_count = day_exchange_count + ?
                    ,month_exchange = month_exchange + ? ,month_exchange_count = month_exchange_count + ?
                    where dist_idx = ?";
            $main_model->db->query($sql, [$amount, $count, $amount, $count, $dist_idx]);
        }
    }

    static public function AddJoin($member_idx, $amount, $model) {
        $sql = "select ifnull(ps.idx,0) as dist_idx from member 
                left join member as ps
                on ps.id = member.dis_id
                where member.idx = ? and ps.u_business <> 1";

        $result = $model->db->query($sql, [$member_idx])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx'])
            return;
       
        $main_model = new MainModel();

        $sql = "select ifnull(dist_idx,0) as dist_idx from tb_dist_sts_info where dist_idx = ?";

        $dist_idx = $result[0]['dist_idx'];
        $result = $main_model->db->query($sql, [$result[0]['dist_idx']])->getResultArray();

        if (!$result || 0 == $result[0]['dist_idx']) {
            $sql = "insert into tb_dist_sts_info(dist_idx,day_join,month_join) value(?,1,1)";
            $main_model->db->query($sql, [$dist_idx]);
        } else {
            $sql = "update tb_dist_sts_info set day_join = day_join + 1 ,month_join = month_join + 1
                    where dist_idx = ?";
            $main_model->db->query($sql, [$dist_idx]);
        }
    }

    static public function DayReset() {
        $main_model = new MainModel();
        $sql = "update tb_dist_sts_info set day_join = 0 ,day_charge = 0,day_exchange = 0,day_charge_count = 0,day_exchange_count = 0";
        $main_model->db->query($sql);
    }

    static public function MonthReset($model) {
        $main_model = new MainModel();
        $sql = "update tb_dist_sts_info set month_join = 0 ,month_charge = 0,month_exchange = 0,month_charge_count = 0,month_exchange_count = 0";
        $main_model->db->query($sql);
    }

    static public function firstChargeStatus($type, $member_idx, $model) {
        // type1 충전, type2 환전
        $sql = "SELECT set_type, set_type_val FROM t_game_config where set_type in ('first_charge_status_onoff','first_exchange_status_onoff', 'first_charge_exchange_status_onoff');";
        $result = $model->db->query($sql, [])->getResultArray();
        $arrConfig = array();
        foreach ($result as $key => $value) {
            $arrConfig[$value['set_type']] = $value['set_type_val'];
        }
        
        if(1 == $type && ('OFF' == $arrConfig['first_charge_status_onoff'] && 'OFF' == $arrConfig['first_charge_exchange_status_onoff'])){
            return;
        }else if(2 == $type && ('OFF' == $arrConfig['first_exchange_status_onoff'] && 'OFF' == $arrConfig['first_charge_exchange_status_onoff'])){
            return;
        }

        // 충전횟수
        $sql = "select charge_total_count, exchange_total_count from total_member_cash where member_idx = ?";
        $result = $model->db->query($sql, [$member_idx])->getResultArray();
        $totalCount = $result[0];
        
        // 오늘의 충전횟수
        $start_dt = date('Y-m-d 00:00:00');
        $end_dt = date('Y-m-d 23:59:59');
        $sql = "SELECT count(*) as todayChargeCount FROM member_money_charge_history WHERE member_idx = ? and status = 3 and update_dt >= ? and update_dt <= ?";
        $result = $model->db->query($sql, [$member_idx, $start_dt, $end_dt])->getResultArray();
        $todayChargeCount = $result[0]['todayChargeCount'];
        
        $sql = "SELECT count(*) as todayExchangeCount FROM member_money_exchange_history WHERE member_idx = ? and status = 3 and update_dt >= ? and update_dt <= ?";
        $result = $model->db->query($sql, [$member_idx, $start_dt, $end_dt])->getResultArray();
        $todayExchangeCount = $result[0]['todayExchangeCount'];
        
        $isClear = false;
        if(1 == $type){
            if('ON' == $arrConfig['first_charge_status_onoff']){
                if($totalCount['charge_total_count'] + $todayChargeCount == 0) $isClear = true;
            }else if('ON' == $arrConfig['first_charge_exchange_status_onoff']){
                if((1 == $totalCount['exchange_total_count'] + $todayExchangeCount)
                    && ($totalCount['charge_total_count'] + $todayChargeCount == 0))
                    $isClear = true;
            }
        }else{
            if('ON' == $arrConfig['first_exchange_status_onoff']){
                if($totalCount['exchange_total_count'] + $todayExchangeCount == 0) $isClear = true;
            }else if('ON' == $arrConfig['first_charge_exchange_status_onoff']){
                if((1 == $totalCount['charge_total_count'] + $todayChargeCount)
                    && ($totalCount['exchange_total_count'] + $todayExchangeCount == 0))
                    $isClear = true;
            }
        }
        
        if(false == $isClear) return;
        
        $sql = "select id, status_condition from lsports_game_type where id > 0";
        $result = $model->db->query($sql, [])->getResultArray();
        $arrGameTypeOn = $arrGameTypeOff = array();
        foreach ($result as $key => $value) {
            if('ON' == $value['status_condition'])
                $arrGameTypeOn[] = $value['id'];
            else
                $arrGameTypeOff[] = $value['id'];
        }
        
        if(0 < count($arrGameTypeOn)){
            $sql = "update member_game_type set status = ? where member_idx = ? and game_type in (".implode(',',$arrGameTypeOn).")";
            $model->db->query($sql, ['ON', $member_idx]);
        }
        
        if(0 < count($arrGameTypeOff)){
            $sql = "update member_game_type set status = ? where member_idx = ? and game_type in (".implode(',',$arrGameTypeOff).")";
            $model->db->query($sql, ['OFF', $member_idx]);
        }
    }
}
