<?php

namespace App\Game;

//use CodeIgniter\Log\Logger;
use App\Models\MemberModel;
use App\Util\httpUtil;
use App\Util\CodeUtil;
use App\Models\TLogCashModel;
use App\Models\TBettingInfo;
use App\Models\TBettingInfoCallback;
use App\Models\TGameIdManager;
use App\Models\KplayLogsModel;
use App\RollingComps\UserPayBack;
use App\RollingComps\UserBettingLose;
use App\Util\Calculate;

class Kplay extends GameAPI {

    private $ApiUrl = 'http://uat.kplayone.com';
    private $AgToken = '3K01hcumxkEiVnHNxvB2DZk7OARDUN7P';
    private $AgCode = 'BON2503';
    private $SercetKey = 'w97CKhSca9FBwfoUJpCD04iALvAFcI3o';


    public function __construct($url, $token, $code, $sercetkey, $logger) {
        $this->ApiUrl = $url;
        $this->AgToken = $token;
        $this->AgCode = $code;
        $this->SercetKey = $sercetkey;
        $this->logger = $logger;
        $this->httpUtil = new httpUtil();
    }

    // api 인증
    public function auth($id, $name, $balance, $domain_url, $prd_id, $type, $is_mobile) {
        $url = $this->ApiUrl . '/auth';
        $body = json_encode(array('user' => array('id' => $id, 'name' => $name, 'balance' => $balance, 'domain_url' => $domain_url, 'language' => 'ko'),
            'prd' => array('id' => $prd_id, 'type' => $type, 'is_mobile' => $is_mobile, 'open_type' => 'r')));
        //$result = $this->httpUtil->curl_post_head_casino($url, $body, $this->AgCode, $this->AgToken);
        $result = $this->httpUtil->curl_post_head_data($url, $body, array('Content-Type: application/json', 'charset=UTF-8', 'ag-code:' . $this->AgCode, 'ag-token: ' . $this->AgToken));
        $result = json_decode($result);

        return $result;
    }

    public function fetchAndSaveGameList() {
        return $this->getGameList();
    }

    //api scheduler 하루에 한번 호출한다.
    public function getGameList() {
        $model = new MemberModel();
        $url = $this->ApiUrl . '/gamelist';
        $body = json_encode(array('language' => 'kr'));


        $result = $this->httpUtil->curl_post_head_data($url, $body, array('Content-Type: application/json', 'charset=UTF-8', 'ag-code:' . $this->AgCode, 'ag-token: ' . $this->AgToken));
        $result = json_decode($result, true);

        //$this->logger->info(':: kplay:: getGameList error message ' . json_encode($result));

        $status = $result['status'];


        if (0 == $status) {
            $this->logger->critical(':: kplay:: getGameList error message ' . $result['error']);
            return "Game error updated.";
        }

        $gameList = $result['game_list'];

        foreach ($gameList as $prd_id => $games) {
            // $this->logger->info(':: kplay:: getGameList error game ' . json_encode($game));

            $this->logger->info(':: kplay:: getGameList error prd_id ' . $prd_id);

            $sql = 'select product_type_id,product_group_id from tb_static_product_id_manager where product_id = ? and provider_id = 1';
            $prd = $model->db->query($sql, [$prd_id])->getResultArray();

            if (!$prd)
                continue;

            foreach ($games as $game) {
                $this->logger->info(':: kplay:: getGameList error game_id ' . $game['game_id']);

                $sql_duplicate = "select * from tb_static_game_id_manager where game_id = ? and product_group_id = ? and provider_id = 1 and product_id = ?  ";
                $game_duplicate = $model->db->query($sql_duplicate, [$game['game_id'], $prd[0]['product_group_id'],$prd_id])->getResultArray();

                if (null != $game_duplicate && true === isset($game_duplicate) && 0 < count($game_duplicate)){
                    $this->logger->info(':: kplay:: getGameList error game_duplicate ' . $game['game_id'].' query : '.$model->getLastQuery());

                    continue;
                }

                $sql_insert = "insert into tb_static_game_id_manager(game_id,game_short_name,is_use,status,gamet_name_en,product_group_id,product_type_id,provider_id,product_id) "
                        . "values(?,?,'ON',1,?,?,?,1,?)";

                $model->db->query($sql_insert, [$game['game_id'], $game['game_name'], $game['game_name'], $prd[0]['product_group_id'], $prd[0]['product_type_id'],$prd_id]);
            }
        }

        return "Game successfully updated.";
    }

    public function requestKplayAPI($productId, $transactionId) {
        $url = $this->ApiUrl . '/results';
        $body = json_encode(array('prd_id' => $productId, 'txn_id' => $transactionId));

        $res_result = $this->httpUtil->curl_get_head_data($url, $body, array('Content-Type: application/json', 'charset=UTF-8', 'ag-code:' . $this->AgCode, 'ag-token: ' . $this->AgToken));
        $result = json_decode($res_result);
        return $result;
    }

    public function results() {

        $this->logger->info('results start');
        $model = new MemberModel();

        $sql = " SELECT * FROM tb_betting_info WHERE status = 'B' AND DATE_ADD(create_dt, INTERVAL 2 MINUTE) <= NOW() and provider_id = 1";

        $noResults = $model->db->query($sql)->getResultArray();

        foreach ($noResults as $item) {
            $productId = $item['product_id'];
            $transactionId = $item['trx_id'];
            $memberIdx = $item['member_idx'];
            //$result = $this->requestKplayAPI($productId,$transactionId);
            $result = $this->requestKplayAPI(200, '644783be1eecf900007f95fc');
            $this->logger->info('$result data ' . json_encode($result));

            $status = $item['status'];
            $type = $item['type'];
            $isCancel = 0;
            if (!isset($result['is_cancel'])) {
                $isCancel = (int) $result['is_cancel'];
            }

            $winMoney = 0;
            if (!isset($result['payout'])) {
                $winMoney = round($result['payout']);
            }

            $betMoney = 0;
            if (!isset($result['stake'])) {
                $betMoney = round($result['stake']);
            }

            if ($status == 1 && $type == 1) {

                $resultType = 'L';
                if (1 == $isCancel) {
                    // 배팅
                    $resultType = 'C';
                } else if ($isCancel == 0 && $winMoney > 0) {
                    $resultType = 'W';
                }

                $this->updateBetting($this->member_info, $item['idx'], $resultType, $transactionId, $transactionAmount, $memberModel);
            }
        }
    }

    public function processRequest($member, $member_model, $function_name, $data) {

        $this->logger->info(':: kplay:: full data ' . $function_name . " => " . json_encode($data));

        /* initialized parameters / 초기화된 매개변수 */
        $this->function_name = $function_name;

        $this->userid = $member->getId();

        $this->member_info = $member;

        /* show logs / 로그 표시 */
        // $this->logger->info(':: kplay:: callback (' . $function_name . ')');
        // $this->logger->info(':: kplay:: member_id => ' . $this->member_info->id);
        // $this->logger->info(':: kplay:: member_idx => ' . $this->member_info->idx);
        // $this->logger->info(':: kplay:: money => ' . $this->member_info->money);
        $this->logger->info(':: kplay:: callback (' . $function_name . ')');
        $this->logger->info("kplay = " . json_encode($data));
        $this->logger->info(':: kplay:: member_idx => ' . $this->member_info->idx);
        $this->logger->info(':: kplay:: money => ' . $this->member_info->money);


        //$this->logger->info(':: kplay:: $_SERVER => ' . json_encode($_SERVER));


        $SercetKey = $_SERVER["HTTP_SECRET_KEY"]; //secret-key

        list($retCode, $result) = $this->authenticateRequest($SercetKey);
        if (0 == $retCode) {
            $this->setResult(0, $result);
            return [$this->result["return_code"], $this->result["message"]];
        }

        /* callback validation / 콜백 검증 */
        $validation_response = $this->callbackValidation($data, $function_name, $member, $member_model);

        if ($validation_response["status"] == 1) {
            //$validation_response["member_info"];
            $this->logger->info(':: kplay:: ' . $function_name . ' Callback Successful (' . $function_name . ')');
            $this->setResult(1, 'Callback Successful');
            $this->$function_name($data, $member_model);
        }

        /* return information as callback response */
        if ($this->result["return_code"] != 1) {
            $this->logger->info(':: Slotbank:: error (' . $this->result["message"] . ') ');
            return [$this->result["return_code"], $this->result["message"]];
        } else {
            /* inserting data in database */
            if ($function_name != 'balance') {

                $kplaylog = new KplayLogsModel();
                $kplaylog = $kplaylog->set('member_idx', $this->member_info->idx);
                $kplaylog = $kplaylog->set('function_name', $function_name);
                //$kplaylog = $kplaylog->set('opkey', $this->opkey);
                $kplaylog = $kplaylog->set('userid', $this->userid);
                //$kplaylog = $kplaylog->set('token', $this->token);
                //$kplaylog = $kplaylog->set('third_party', $this->third_party);
                $kplaylog = $kplaylog->set('times', $this->times);
                $insert_kplaylog = $kplaylog->insert();
            }

            /* End */

            $this->setResult(1);
            $this->logger->info(':: Slotbank:: success (' . $this->result["balance"] . ') message : ' . $this->result["message"]);
            return [$this->result["return_code"], $this->result["balance"]];
        }
    }

    private function authenticateRequest($secretKeyToken) {
        if ($secretKeyToken != $this->SercetKey) {
            return [0, 'ACCESS_DENIED'];
        }
        return [1, 'success'];
    }

    public function isLoginById($k_id, $function_name, $member_model) {
        $this->logger->info(':: kplay:: callback (' . $k_id . ', ' . $function_name . ')');

        // check of logged-in
        $member = $member_model->getMemberByKplayId($k_id);

        if ($member == null) {
            return [null, 'INVALID_USER'];
        }

        if ($member->getUBusiness() != 1) {
            return [null, '총판은 배팅 이용이 불가능합니다.'];
        }

        if ($member->getStatus() == 11) {
            $response['messages'] = '관리자 승인이 필요합니다.';
            return [null, '관리자 승인이 필요합니다.'];
        }

        if ('credit' != $function_name) {
            if ($member->getStatus() == 2 || $member->getStatus() == 3) {
                return [null, '사용이 불가능 한 계정으로 관리자에게 문의바랍니다.'];
            }
        }

        return [$member, ''];
    }

    public function hasError() {
        return $this->result["return_code"] == 1 ? true : false;
    }

    public function callbackValidation($data, $function_name, $member, $member_model) {
        $this->logger->info(':: kplay:: callbackValidation()');
        /* check if user information exist / 사용자 정보가 존재하는지 확인 */
        if (!isset($this->member_info) || !$this->member_info) {
            $this->logger->error(':: SlotBankController::' . $function_name . ' => Invalid User ID');
            $this->setResult(400, 'Invalid User ID');
            return ['status' => 0, 'member_info' => $this->member_info, 'message' => 'Invalid User ID'];
        } else {
            $this->logger->info(':: kplay:: member.id => ' . $this->member_info->id);
            $this->logger->info(':: kplay:: member.idx => ' . $this->member_info->idx);
            $this->logger->info(':: kplay:: member.money => ' . $this->member_info->money);
        }

        $client_ip = CodeUtil::get_client_ip();
        $sql = "select * from tb_static_whitelist_kplay where ip = ?";
        $result = $member_model->db->query($sql, [$client_ip])->getResultArray();

        if (!$result || 0 == count($result)) {
            $this->logger->error(':: CasinoController::' . $function_name . ' => Invalid IP address' . ' client ip :' . $client_ip);
            $this->setResult(400, 'Invalid IP address');
            return ['status' => 0, 'member_info' => $this->member_info, 'message' => 'Invalid IP address'];
        }

        return ['status' => 1, 'member_info' => $this->member_info, 'message' => 'Missing Parameters'];
    }

    public function setResult($code, $message = null, $balance = 0) {
        $this->result["return_code"] = $code;
        $this->result["message"] = $message;

        if ($code == 1) {
            $this->result["balance"] = $this->member_info->money;
        }
    }

    private function getBettingData($memberIdx, $transactionId, $memberModel) {
        $sql = "select * from tb_betting_info where member_idx = ? and trx_id = ? and provider_id = 1";
        $betinfo = $memberModel->db->query($sql, [$memberIdx, $transactionId])->getResultArray();
        return $betinfo;
    }

    private function addBet($member, $transactionId, $transactionAmount, $productId, $gameId, $roundId, $memberModel) {

        $this->logger->info(':: kplay:: addBet $transactionId ' . $transactionId);
        $this->logger->info(':: kplay:: addBet $transactionAmount ' . $transactionAmount);
        $this->logger->info(':: kplay:: addBet $productId ' . $productId);
        $this->logger->info(':: kplay:: addBet $gameId ' . $gameId);
        $this->logger->info(':: kplay:: addBet $roundId ' . $roundId);

        $sql = "select * from tb_static_product_id_manager where product_id = ? and provider_id = 1";
        $product = $memberModel->db->query($sql, [$productId])->getResultArray();

        $this->logger->info(':: kplay:: addBet query ' . $memberModel->getLastQuery());

        $this->logger->info(':: kplay:: addBet product ' . json_encode($product));

        // after money
        $af_money = $member->getMoney() - $transactionAmount;

        $sql = "insert into tb_betting_info (member_idx,status,trx_id, round_id, bet_money, hold_money, game_id, product_id, product_type_id, provider_id,product_group_id)
        values (?,'B', ?, ?, ?, ?,?,?,?,?,?)";
        $memberModel->db->query($sql, [$member->getIdx(), $transactionId, $roundId, $transactionAmount, $af_money, $gameId
            , $productId, $product[0]['product_type_id'], $product[0]['provider_id'], $product[0]['product_group_id']]);
        //$acIdx = $memberModel->getInsertID();

        $this->logger->info(':: kplay:: addBet query insert' . $memberModel->getLastQuery());

        $sql = 'SELECT idx FROM tb_betting_info where member_idx = ? order by idx desc limit 1';
        $acIdx = $memberModel->db->query($sql, [$member->getIdx()])->getResultArray()[0];

        $sql = "update member set money = money - ? where idx = ?";
        $memberModel->db->query($sql, [$transactionAmount, $member->getIdx()]);

        $log = new TLogCashModel();
        $uKey = md5($member->getIdx() . strtotime('now'));
        $log->insertCashLog_new($uKey, $member->getIdx(), ADD_BET, $acIdx, $transactionAmount, $member->getMoney(), $af_money, 0, 0, 0, 'M', '카지노베팅');
        return $acIdx;
    }

    private function updateBetting($member, $acIdx, $resultType, $transactionId, $transactionAmount, $memberModel) {
        $UserBettingLose = new UserBettingLose();

        $sql = "select bet_money from tb_betting_info where member_idx = ? and trx_id = ?";
        $betInfo = $memberModel->db->query($sql, [$member->getIdx(), $transactionId])->getResultArray()[0];

        // $amount = $transactionAmount;
        // $acCode = BET_RESULT;
        $commend = $betInfo["product_type_id"] == 1 ? 'casino' : 'slot';
        
        $amount = $transactionAmount;
        $acCode = BET_RESULT;
        
    
        $this->logger->info("\n\n\nupdateBetting: " . $resultType);
        $this->logger->info("updateBetting: Member IDX: " . $member->getIdx());
        $this->logger->info("updateBetting: Commend: " . $commend);
        $this->logger->info("updateBetting: Bet Money: " . $betInfo["bet_money"]);
        $this->logger->info("updateBetting: Win Money: " . $transactionAmount);
        $this->logger->info("updateBetting: Bet Info: " . json_encode($betInfo));
        

        if($betInfo["bet_money"] == $transactionAmount && $commend == "casino") {
            $resultType = 'C';
            $this->logger->info("updateBetting: Result type is draw.");
        }

        if ('C' != $resultType) {
            Calculate::updateChargeBetMoney($member->getIdx(), strtoupper($commend), $betInfo["bet_money"], $memberModel, $this->logger);
            UserPayBack::AddBetting($member->getIdx(), $betInfo["bet_money"], $memberModel);
            UserBettingLose::RewardBettingComps($member->getIdx(), $commend, $betInfo["bet_money"], $this->logger, $memberModel);
        }


        if ('C' == $resultType) {
            $amount = - $amount;
            $acCode = BET_CANCEL;
            $UserBettingLose->AddBetting($member->getIdx(), 'casino', $bet_money, $memberModel); // 롤링콤프 베팅금액
        } else if ('W' == $resultType) {
            // $UserBettingLose->AddBetting($member->getIdx(), 'casino', $bet_money, $memberModel); // 롤링콤프 베팅금액
            UserBettingLose::RewardWinComps($member->getIdx(), $commend, $betInfo["bet_money"], $this->logger, $memberModel);
        } else if ('L' == $resultType) {
            // $UserBettingLose->AddBetting($member->getIdx(), 'casino', $bet_money, $memberModel); // 롤링콤프 베팅금액
            // $UserBettingLose->AddLoseBetting($member->getIdx(), 'casino', $bet_money, $this->logger, $memberModel); // 롤링콤프 낙첨금액
            UserBettingLose::RewardLoseComps($member->getIdx(), $commend, $betInfo["bet_money"], $this->logger, $memberModel);
        }

        /* override winning amount */
        if($betInfo["bet_money"] == $transactionAmount && $commend == "casino") {
            $amount = - $amount;
            $resultType = 'W';
            $acCode = BET_RESULT;
            $this->logger->info("updateBetting: Override to win after giving points.");
        }


        $sql = 'select idx from member_money_charge_history where member_idx = ? and status = 3 order by update_dt desc limit 1';
        $bet_idx = $memberModel->db->query($sql, [$member->getIdx()])->getResultArray()[0];

        // $this->logger->info('::kplay updateBetting:: query ' . $memberModel->getLastQuery());

        if(1 == $betInfo["product_type_id"]){
            $sql = "UPDATE member_money_charge_history SET casino_bet_money = casino_bet_money + ? WHERE idx = ?"; 
            $memberModel->db->query($sql, [$betInfo["bet_money"], $bet_idx]);    
        }else{
            $sql = "UPDATE member_money_charge_history SET slot_bet_money = slot_bet_money + ? WHERE idx = ?"; 
            $memberModel->db->query($sql, [$betInfo["bet_money"], $bet_idx]);    
        }



        // $sql = "UPDATE member_money_charge_history SET casino_bet_money = casino_bet_money + ? WHERE idx = ?";
        // $memberModel->db->query($sql, [$bet_money, $bet_idx]);

        // $this->logger->info('::kplay updateBetting:: query ' . $memberModel->getLastQuery());

        $sql = "update tb_betting_info set status = ?,take_money = take_money + ?, hold_money = ?, calc_dt = now() where member_idx = ? and trx_id = ?";
        $memberModel->db->query($sql, [$resultType, $amount, $member->getMoney() + $transactionAmount, $member->getIdx(), $transactionId]);

        $this->logger->info('::kplay updateBetting:: query ' . $memberModel->getLastQuery());

        $sql = "update member set money = money + ? where idx = ?";
        $memberModel->db->query($sql, [$transactionAmount, $member->getIdx()]);

        $this->logger->info('::kplay updateBetting:: query ' . $memberModel->getLastQuery());

        $log = new TLogCashModel();
        $ukey = md5($member->getIdx() . strtotime('now'));
        $log->insertCashLog_new($uKey, $member->getIdx(), $acCode, $acIdx, $transactionAmount, $member->getMoney(), $member->getMoney() + $transactionAmount, 0, 0, 0, 'P', '베팅결과처리');
    }

    private function updateBettingBonus($member, $acIdx, $resultType, $transactionId, $transactionAmount, $promoType, $memberModel) {
        $sql = "update tb_betting_info set status = ?,take_money = take_money + ?, hold_money = ? ,bonus_type = ? ,calc_dt = now() where member_idx = ? and trx_id = ?";
        $memberModel->db->query($sql, [$resultType, $transactionAmount, $member->getMoney() + $transactionAmount, $promoType, $member->getIdx(), $transactionId]);

        $this->logger->info('::kplay updateBettingBonus:: query ' . $memberModel->getLastQuery());

        $sql = "update member set money = money + ? where idx = ?";
        $memberModel->db->query($sql, [$transactionAmount, $member->getIdx()]);

        $this->logger->info('::kplay updateBettingBonus:: query ' . $memberModel->getLastQuery());

        $log = new TLogCashModel();
        $ukey = md5($member->getIdx() . strtotime('now'));
        $log->insertCashLog_new($uKey, $member->getIdx(), BET_RESULT, $acIdx, $transactionAmount, $member->getMoney(), $member->getMoney() + $transactionAmount, 0, 0, 0, 'P', '베팅결과처리');
    }

    private function addBetBonus($member, $transactionId, $transactionAmount, $productId, $gameId, $roundId, $promoType, $memberModel) {
        $sql = "select * from tb_static_product_id_manager where product_id = ? and provider_id = 1";
        $product = $memberModel->db->query($sql, [$productId])->getResultArray();

        // after money
        $af_money = $member->getMoney() - $transactionAmount;

        $sql = "insert into tb_betting_info (member_idx,status,trx_id, round_id, bet_money, hold_money, game_id, product_id, product_type_id, provider_id,product_group_id,bonus_type)
        values (?,'W', ?, ?, ?, ?,?,?,?,?,?,?)";
        $memberModel->db->query($sql, [$member->getIdx(), $transactionId, $roundId, $transactionAmount, $af_money, $gameId
            , $productId, $product[0]['product_type_id'], $product[0]['provider_id'], $product[0]['product_group_id'], $promoType]);
        //$acIdx = $memberModel->getInsertID();

        $this->logger->info('::kplay addBetBonus:: query ' . $memberModel->getLastQuery());

        $sql = 'SELECT idx FROM tb_betting_info where member_idx = ? order by idx desc limit 1';
        $acIdx = $memberModel->db->query($sql, [$member->getIdx()])->getResultArray()[0];

        $this->logger->info('::kplay addBetBonus:: query ' . $memberModel->getLastQuery());

        $sql = "update member set money = money + ? where idx = ?";
        $memberModel->db->query($sql, [$transactionAmount, $member->getIdx()]);

        $this->logger->info('::kplay addBetBonus:: query ' . $memberModel->getLastQuery());

        $log = new TLogCashModel();
        $ukey = md5($member->getIdx() . strtotime('now'));
        $log->insertCashLog_new($uKey, $member->getIdx(), ADD_BET, $acIdx, $transactionAmount, $member->getMoney(), $af_money, 0, 0, 0, 'P', '보너스 지급');
        return $acIdx;
    }

    public function debit($post, $memberModel) {
        $transactionId = isset($post['txn_id']) ? $post['txn_id'] : '';
        $transactionAmount = isset($post['amount']) ? $post['amount'] : 0;
        $productId = isset($post['prd_id']) ? $post['prd_id'] : 0;
        $gameId = isset($post['game_id']) ? $post['game_id'] : '';


        $tb_static_game_id_manager = new TGameIdManager();
        $game_information = $tb_static_game_id_manager->getGameInformation($gameId, 1, $productId);

        $this->logger->info('kplay debit debit');
        $this->logger->info(':: kplay debit:: ' . json_encode($post));
        $this->logger->info(':: kplay debit:: game_info ID' . $gameId);
        $this->logger->info(':: kplay debit:: game_info ' . json_encode($game_information));
        $this->logger->info(':: kplay debit:: game_info game id ' . json_encode($game_information["game_id"]));
        $this->logger->info(':: kplay debit:: game_info transactionId ' . $transactionId);
        // $this->logger->info(':: kplay:: debit transactionAmount ' . $transactionAmount);
        // $this->logger->info(':: kplay:: debit productId ' . $productId);
        // $this->logger->info(':: kplay:: debit gameId ' . $gameId);

        if ($this->member_info->getMoney() < $transactionAmount) {
            return [0, 0, 'INSUFFICIENT_FUNDS'];
        }
        // 베팅 데이터를 가져온다.
        $betinfo = $this->getBettingData($this->member_info->getIdx(), $transactionId, $memberModel);
        //if (true === empty($betinfo)) {
        if (false === empty($betinfo)) {
            return [0, 0, 'DUPLICATE_DEBIT'];
        }

        $acIdx = $this->addBet($this->member_info, $transactionId, $transactionAmount, $productId, $gameId, $roundId, $memberModel);

        $UserBettingLose = new UserBettingLose();

        //echo $_POST['creditAmount'];
        // 배팅
        if (!isset($post['credit_amount'])) {
            return [1, $this->member_info->getMoney() - $transactionAmount, 'OK'];
            // 배팅과 동시에 결과가 나온거다     
        } else {
            $resultType = 'L';
            if (0 < $post['credit_amount']) {
                $resultType = 'W';
            }

            $this->updateBetting($this->member_info, $acIdx, $resultType, $transactionId, $post['credit_amount'], $memberModel);

            return [1, $this->member_info->getMoney() - $transactionAmount + $_POST['credit_amount'], 'OK'];
        }
    }

    public function buyin($post, $memberModel) {
        $transactionId = isset($post['txn_id']) ? $post['txn_id'] : '';
        $transactionAmount = isset($post['amount']) ? $post['amount'] : 0;
        $productId = isset($post['prd_id']) ? $post['prd_id'] : 0;
        $gameId = isset($post['game_id']) ? $post['game_id'] : '';

        $this->logger->info(':: kplay:: buyin ' . $json_encode($post));
        // $this->logger->info(':: kplay:: buyin transactionId => ' . $transactionId);
        // $this->logger->info(':: kplay:: buyin transactionAmount ' . $transactionAmount);
        // $this->logger->info(':: kplay:: buyin productId ' . $productId);
        // $this->logger->info(':: kplay:: buyin gameId ' . $gameId);

        if ($this->member_info->getMoney() < $transactionAmount) {
            return [0, 0, 'INSUFFICIENT_FUNDS'];
        }
        // 베팅 데이터를 가져온다.
        $betinfo = $this->getBettingData($this->member_info->getIdx(), $transactionId, $memberModel);
        //if (true === empty($betinfo)) {
        if (false === empty($betinfo)) {
            return [0, 0, 'DUPLICATE_DEBIT'];
        }

        $acIdx = $this->addBet($this->member_info, $transactionId, $transactionAmount, $productId, $game_information["game_id"], $roundId, $memberModel);

        $UserBettingLose = new UserBettingLose();

        //echo $_POST['creditAmount'];
        // 배팅
        if (!isset($post['credit_amount'])) {
            return [1, $this->member_info->getMoney() - $transactionAmount, 'OK'];
            // 배팅과 동시에 결과가 나온거다     
        } else {
            $resultType = 'L';
            if (0 < $post['credit_amount']) {
                $resultType = 'W';
            }

            $this->updateBetting($this->member_info, $acIdx, $resultType, $transactionId, $post['credit_amount'], $memberModel);

            return [1, $this->member_info->getMoney() - $transactionAmount + $_POST['credit_amount'], 'OK'];
        }
    }

    public function credit($post, $memberModel) {
        $transactionId = isset($post['txn_id']) ? $post['txn_id'] : '';
        $transactionAmount = isset($post['amount']) ? $post['amount'] : 0;
        $productId = isset($post['prd_id']) ? $post['prd_id'] : 0;
        $is_cancel = isset($post['is_cancel']) ? $post['is_cancel'] : 0;

        // 베팅 데이터를 가져온다.
        $betinfo = $this->getBettingData($this->member_info->getIdx(), $transactionId, $memberModel);
        if (empty($betinfo)) {
            return [0, 0, 'INVALID_DEBIT'];
        }

        if ('B' != $betinfo[0]['status']) {
            return [0, 0, 'DUPLICATE_CREDIT'];
        }

        $resultType = 'L';
        if (1 == $is_cancel) {
            // 배팅
            $resultType = 'C';
        } else if (0 < $transactionAmount) {
            $resultType = 'W';
        }

        $this->updateBetting($this->member_info, $betinfo[0]['idx'], $resultType, $transactionId, $transactionAmount, $memberModel);
        return [1, $this->member_info->getMoney() + $transactionAmount, 'OK'];
    }

    //callback
    public function balance($post, $memberModel) {
        $productId = isset($post['prd_id']) ? $post['prd_id'] : 0;

        // $this->logger->info(':: kplay:: balance productId ' . $productId);
        $this->logger->info(':: kplay:: balance productId ' . $productId);

        return [1, $this->member_info->getMoney(), 'OK'];
    }

    public function bonus($post, $memberModel) {
        $transactionId = isset($post['txn_id']) ? $post['txn_id'] : '';
        $transactionAmount = isset($post['amount']) ? $post['amount'] : 0;
        $promoType = isset($post['type']) ? $post['type'] : '';
        $productId = isset($post['prd_id']) ? $post['prd_id'] : 0;
        $gameId = isset($post['game_id']) ? $post['game_id'] : '';

        // 베팅 데이터를 가져온다.
        //$betinfo = $this->getBettingData($member->getIdx(), $transactionId, $memberModel);
        //if (empty($betinfo)) {
        //    return [0, 0, 'INVALID_DEBIT'];
        //}
        //if ('L' != $betinfo[0]['status']) {
        //    return [0, 0, 'DUPLICATE_CREDIT'];
        //}
        // 배팅
        $this->addBetBonus($this->member_info, $transactionId, $transactionAmount, $productId, $gameId, 0, $promoType, $memberModel);

        return [1, $this->member_info->getMoney() + $transactionAmount, 'OK'];
    }

}
