<?php namespace App\Models;

use CodeIgniter\Model;

class GamePlayedModel extends Model
{
    protected $DBGroup      = 'default';
    protected $table        = 'game_played';
    protected $primaryKey   = 'idx';

    protected $returnType = 'array';
    protected $useSoftDeletes = false;
    protected $allowedFields = [
        'idx',
        'game_id',
        'member_id',
        'create_datetime',
        'last_played_datetime',
    ];

    protected $validationRules = [];
    protected $validationMessages = [];
    protected $skipValidation = false;

    public function setAsRecentlyPlayed($game_id, $member_idx)
    {
        $this->where('game_id', $game_id);
        $this->where('member_id', $member_idx);  

        $check_exist = $this->first();

        if($check_exist)
        {
            $this->where('game_id', $game_id);
            $this->where('member_id', $member_idx);
            $this->set('last_played_datetime', date('Y-m-d H:i:s'));
            $this->update();
        }
        else
        {
            $this->set('game_id', $game_id);
            $this->set('member_id', $member_idx);
            $this->set('last_played_datetime', date('Y-m-d H:i:s'));
            $this->set('create_datetime', date('Y-m-d H:i:s'));
            $this->insert();
        }

    }
}