<?php namespace App\Models;

use App\Util\CodeUtil;
use CodeIgniter\Model;

class MenuQnAModel extends Model
{
    protected $DBGroup = 'default';
    protected $table = 'menu_qna';
    protected $primaryKey = 'idx';

    protected $returnType = 'array';
//    protected $returnType = 'App\Entities\Member';
    protected $useSoftDeletes = false;
    protected $allowedFields = [
        
        'member_idx',
        'a_id',
        'title',
        'contents',
        'create_dt',
        'delete_dt'
    ];

    protected $validationRules = [];
    protected $validationMessages = [];
    protected $skipValidation = false;

    public function addQ($memberIdx, $title, $contents):bool {
        try {
            $this->insert([
                'member_idx' => $memberIdx,
                'title' => $title,
                'contents' => $contents
            ]);
            return true;
        } catch (\ReflectionException $e) {
            return false;
        }

    }
    
    // 하나의 게시글 가져온다.
    public function selectQOneToOne($idx):bool {
        try {
            return $this->select('idx, member_idx, title, contents')
            ->where('idx', $idx)
            ->find();
        } catch (\ReflectionException $e) {
            return null;
        }
    }
    
    // 하나의 게시글 삭제한다.
    public function deleteQ($idx):bool {
        try {
            return $this->deleteQ
            ->where('idx', $idx)
            ->find();
            
            //return true;
        } catch (\ReflectionException $e) {
            return null;
        }
    }
    public function hasInquiryCount()
    {
        $this->select(['menu_qna.idx']);
        $this->join('member as m', 'menu_qna.member_idx = m.idx', 'left');
        $this->where('menu_qna.member_idx', session()->get('member_idx'));
        $this->where('menu_qna.is_view', 'Y');
        $this->where('delete_dt', NULL);

        $inquiry_count = $this->countAllResults();

        if ($inquiry_count == 0)
        {
            return false;
        }

        return true;
    }

    public function deleteInquiryByIdx($inquiry_idx)
    {
        $data['delete_dt']  = date('Y-m-d H:i:s');
        
        $this->set('delete_dt', $data['delete_dt']);
        $this->where('idx', $inquiry_idx);

        return $this->update();

    }

    public function deleteInquiryByUser()
    {
        $data['delete_dt']          = date('Y-m-d H:i:s');
        $member_idx                 = intval(session()->get('member_idx'));
        $this->set('delete_dt', $data['delete_dt']);
        $this->where('member_idx', $member_idx);

        return $this->update();
    }

}