<?php

namespace App\Models;

use CodeIgniter\Model;

class TProductGroupManager extends Model
{

    protected $DBGroup = 'default';
    protected $table = 'tb_static_product_group_manager';
    protected $primaryKey = 'product_group_id';
    protected $returnType = 'array';
    protected $useSoftDeletes = false;
    protected $allowedFields = [
        'create_dt',
        'update_dt',
        'product_group_name',
        'desc',
        'img_url',
        'desc',
        'slotbank_id',
        'slotbank_lobby_code',
        'product_type_id',
    ];
    protected $validationRules = [];
    protected $validationMessages = [];
    protected $skipValidation = false;

    public function getFirst($product_type_id) {
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->where('tb_static_switch_manager.is_use', 'ON');
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->orderBy('tb_static_product_group_manager.product_group_id', 'asc');
        $query = $query->join('tb_static_switch_manager', 'tb_static_switch_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $list = $query->first();
        return $list;
    }
    public function getProductListByType($product_type_id) {
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->where('tb_static_switch_manager.is_use', 'ON');
        $query = $this->where('product_type_id', $product_type_id);
        $query = $this->orderBy('tb_static_product_group_manager.product_group_id', 'asc');
        $query = $query->join('tb_static_switch_manager', 'tb_static_switch_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $list = $query->findAll();
        return $list;
    }
    public function getProductListByTypeProvider($product_type_id, $provider_id) {
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->where('tb_static_switch_manager.is_use', 'ON');
        $query = $this->where('tb_static_product_id_manager.provider_id', $provider_id);
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->orderBy('tb_static_product_group_manager.product_group_id', 'asc');
        $query = $query->join('tb_static_switch_manager', 'tb_static_switch_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $query = $query->join('tb_static_product_id_manager', 'tb_static_product_id_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $list = $query->findAll();
        return $list;
    }
    public function getProductListByTypeProviderV2($product_type_id) {
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->where('tb_static_switch_manager.is_use', 'ON');
        $query = $this->where('tb_static_product_group_manager.product_type_id', $product_type_id);
        $query = $this->orderBy('tb_static_product_group_manager.product_group_id', 'asc');
        $query = $query->join('tb_static_switch_manager', 'tb_static_switch_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $list = $query->findAll();
        return $list;
    }
    public function getProductInformation($product_group_id) {
        $query = $this->where("tb_static_product_group_manager.product_group_id", $product_group_id);
        $query = $query->join('tb_static_switch_manager', 'tb_static_switch_manager.product_group_id = tb_static_product_group_manager.product_group_id');
        $data = $query->first();
        return $data;
    }
}
