<?php

namespace App\Models;

use CodeIgniter\Model;

class TSTTSwitchManager extends Model
{
    protected $DBGroup = 'default';
    protected $table = 'tb_static_switch_manager';
    protected $primaryKey = 'provider_id,product_type_id';
    protected $returnType = 'array';
    protected $useSoftDeletes = false;
    protected $allowedFields = [
        'is_use',
        'create_dt',
        'update_dt',
        'product_group_id'
        
    ];
    protected $validationRules = [];
    protected $validationMessages = [];
    protected $skipValidation = false;
    
    public function getCanUseData($product_type_id){
    // 사용가능한 프로바이더를 얻어온다.
        $sql = "SELECT gm.product_group_name, gm.product_group_id, stm.provider_id, gm.product_type_id, gm.img_url 
        FROM tb_static_switch_manager as stm
        LEFT JOIN tb_static_product_group_manager as gm ON gm.product_group_id = stm.product_group_id
        WHERE gm.product_type_id = ? AND stm.is_use = 'ON' and gm.order_priority is NOT NULL
        ORDER BY gm.front_order_priority ASC"; 

        return $this->db->query($sql, [$product_type_id])->getResultArray();
    }
}
