<?php

namespace App\RollingComps;

use App\Models\TLogCashModel;

//use App\Util\DateTimeUtil;

class UserBettingLose {

    static public function AddBetting($member_idx, $type, $amount, $model) {

        $sql = "select member_idx from tb_user_rolling_comps where member_idx = ? and type = ?";
        $result = $model->db->query($sql, [$member_idx, $type])->getResultArray();

        if ($result === false || empty($result)) {
            $sql = 'INSERT INTO tb_user_rolling_comps (member_idx,type,bet_total) VALUES (?,?,?)';
            $model->db->query($sql, [$member_idx, $type, $amount]);
        } else if (0 != $result[0]['member_idx']) {
            $sql = 'update tb_user_rolling_comps set bet_total = bet_total + ? where member_idx = ? and type = ?';
            $model->db->query($sql, [$amount, $member_idx, $type]);
        }
    }
    
    static public function decPoint($reward,$money,$point,$member_idx,$model){
        $m_money = 0;
        $m_point = abs($reward);
        if(abs($reward) <= $point){
            $sql = "update member set point = point + ? where idx = ?";
            //$model->setQueryData_pre($sql, [$reward, $member_idx]);
            $model->db->query($sql, [$reward, $member_idx]);
        } else{
            $m_money = abs($reward) - $point;
            if($money < $m_money){
                $sql = "update member set point = point + ? where idx = ?";
                //$model->setQueryData_pre($sql, [$reward, $member_idx]);
                $model->db->query($sql, [$reward, $member_idx]);
                return [$m_money,$m_point];
            }
            
            $m_point = $point;
            $sql = "update member set point = point - ?,money = money - ? where idx = ?";
            //$model->setQueryData_pre($sql, [$m_point,$m_money, $member_idx]);
            $model->db->query($sql, [$m_point,$m_money,$member_idx]);
        }
        
        return [$m_money,$m_point];
    }

    static public function RewardBettingComps($member_idx, $type, $bet_total, $logger, $model) {

        $tLogCashModel = new TLogCashModel();
        $sql = "select mb.money,mb.point,rcms.type,rcms.myself_bet ,
                if(parent.u_business <> 1, 0,rcms.recommender_bet) as recommender_bet,
                mb.recommend_member,
                mb.nick_name,
                parent.point as p_point,
                parent.money as p_money,
                parent.u_business as p_u_business,
                member_extend.total_reward_point,
                ifnull(pmex.recom_total_reward_point,0) as p_total_reward_point
                from member as mb 
                left join member as parent on mb.recommend_member = parent.idx
                left join tb_static_rolling_comps as rcms on mb.level = rcms.level
                left join member_extend on member_extend.member_idx = mb.idx
                left join member_extend as pmex on pmex.member_idx = mb.recommend_member
                where mb.idx = ? and rcms.type =  ? and mb.u_business ='1'";

        try {
            //$model->db->transStart();
            $result = $model->db->query($sql, [$member_idx, $type])->getResultArray();

            if (!isset($result) || empty($result)) {
                //$model->db->transRollback();
                return;
            }
            //$logger->error('RewardBettingComps bet_total : ' . json_encode($result[0]));
            //$logger->error('RewardBettingComps bet_total : ' . $bet_total);
            $reward = intval(($bet_total * $result[0]['myself_bet'] * 0.01));
            //$logger->error('RewardBettingComps reward : ' . $reward);
            if ('ON' == config(App::class)->IS_ON_MAX_ROLLING_COMPS) {
                if (0 < $reward && (MAX_BET_PAY_BACK_POINT <= $result[0]['total_reward_point'])) {
                    $reward = 0;
                } else if (0 < $reward && (MAX_BET_PAY_BACK_POINT <= $result[0]['total_reward_point'] + $reward)) {
                    $reward = MAX_BET_PAY_BACK_POINT - $result[0]['total_reward_point'];
                }
            }
            
            //$logger->error('RewardBettingComps reward 1: ' . $reward);

            if (0 != $reward) {
                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                    $logger->error('RewardBettingComps reward 2: ' . $reward);
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                    $logger->error('RewardBettingComps reward 3: ' . $reward);
                }

                //$reward_temp = 0;
                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['money'],$result[0]['point'],$member_idx,$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $member_idx]);
                }
                

                $sql = "update member_extend set total_reward_point = total_reward_point + ? where member_idx = ?";
                $model->db->query($sql, [intval($reward), $member_idx]);


                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                $betting_rolling_types = [
                    'prematch_s' => '프리매치 단폴 배팅보상',
                    'prematch_d' => '프리매치 2폴 이상 배팅보상',
                    'inplay_s' => '실시간 단폴 배팅보상',
                    'inplay_d' => '실시간 2폴 이상 배팅보상',
                    'casino' => '카지노 배팅보상',
                    'powerball' => '미니게임 외 배팅보상',
                    'eos_powerball' => '미니게임 외 배팅보상',
                    'power_ladder' => '미니게임 외 배팅보상',
                    'kino_ladder' => '미니게임 외 배팅보상',
                    'virtual_soccer' => '미니게임 외 배팅보상',
                    'slot' => '슬롯 배팅보상',
                ];

                $a_comment = $betting_rolling_types[$type] . '(배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';
                //$a_comment = '';
                $ukey = md5($member_idx . strtotime('now'));
                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['point'], $result[0]['point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_BACK_REWARD_POINT, 0, -$m_money, $result[0]['money'], 0, 0, 0, $kind, $a_comment);
                    }
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['point'], $result[0]['point'] + $reward, $kind, $a_comment);
                }
            }

            //$logger->error('RewardBettingComps rec : ' . json_encode($result[0]));
            if (0 < $result[0]['recommender_bet'] && 0 != $bet_total && 1 == $result[0]['p_u_business']) {
                $reward = ($bet_total * $result[0]['recommender_bet'] * 0.01);
                if (0 == $reward) {
                    //$model->db->transComplete();
                    return;
                }

                if ('ON' == config(App::class)->IS_ON_MAX_ROLLING_COMPS) {
                    if (0 < $reward && (MAX_BET_PAY_BACK_POINT <= $result[0]['p_total_reward_point'])) {

                        //$model->db->transComplete();

                        return;
                    } else if (0 < $reward && (MAX_BET_PAY_BACK_POINT <= $result[0]['p_total_reward_point'] + $reward)) {
                        $reward = MAX_BET_PAY_BACK_POINT - $result[0]['p_total_reward_point'];
                    }
                }

                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                }

                //$logger->error('RewardBettingComps rec $reward : ' . $reward);

                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['p_money'],$result[0]['p_point'],$result[0]['recommend_member'],$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $result[0]['recommend_member']]);
                }
                //$sql = "update member set point = point + ? where idx = ?";
                
                //$logger->error('RewardBettingComps rec query : ' . $model->getLastQuery());

                $sql = "update member_extend set recom_total_reward_point = recom_total_reward_point + ? where member_idx = ?";
                $model->db->query($sql, [$reward, $result[0]['recommend_member']]);


                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                $a_comment = $betting_rolling_types[$type] . '지인 닉네임 : ' . $result[0]['nick_name'] . ' (추천인 배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';

                $ukey = md5($result[0]['recommend_member'] . strtotime('now'));
                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                    $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['p_point'], $result[0]['p_point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_BACK_REWARD_POINT,0, -$m_money, $result[0]['p_money'], 0, 0, 0, $kind, $a_comment);
                    }
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['p_point'], $result[0]['p_point'] + $reward, $kind, $a_comment);
                }
            }

            //$model->db->transComplete();
        } catch (\mysqli_sql_exception $e) {
            $logger->error(':::::::::::::::  RewardBettingComps error : ' . $e->getMessage());
            $logger->error(':::::::::::::::  RewardBettingComps query : ' . $model->getLastQuery());
            //$model->db->transRollback();
        }
    }

    static public function AddLoseBetting($member_idx, $type, $amount, $logger, $model) {

        $sql = "select member_idx from tb_user_rolling_comps where member_idx = ? and type = ?";
        $result = $model->db->query($sql, [$member_idx, $type])->getResultArray();

        $logger->info('doMiniTotalCalculate : AddLoseBetting member_idx' . $member_idx);
        $logger->info('doMiniTotalCalculate : AddLoseBetting type' . $type);
        $logger->info('doMiniTotalCalculate : AddLoseBetting ' . json_encode($result));
        if (!isset($result) || empty($result)) {
            $sql = 'INSERT INTO tb_user_rolling_comps (member_idx,type,lose_bet_total) VALUES (?,?,?)';
            $model->db->query($sql, [$member_idx, $type, $amount]);

            $logger->info('doMiniTotalCalculate : AddLoseBetting 1');
        } else if (0 != $result[0]['member_idx']) {
            $sql = 'update tb_user_rolling_comps set lose_bet_total = lose_bet_total + ? where member_idx = ? and type = ?';
            $model->db->query($sql, [$amount, $member_idx, $type]);
            $logger->info('doMiniTotalCalculate : AddLoseBetting 2');
        } else {
            $logger->info('doMiniTotalCalculate : AddLoseBetting 3');
        }
    }

    static public function RewardLoseComps($member_idx, $type, $bet_total, $logger, $model) {
        //$memberModel = new MemberModel();
        $logger->info('RewardLoseComps start');
        $tLogCashModel = new TLogCashModel();
        $sql = "select mb.money,mb.point,rcms.type,rcms.myself_lose ,
                if(parent.u_business <> 1, 0,rcms.recommender_lose) as recommender_lose,
                mb.recommend_member,
                parent.point as p_point,
                parent.money as p_money,
                parent.u_business as p_u_business
                from member as mb 
                left join member as parent on mb.recommend_member = parent.idx
                left join tb_static_rolling_comps as rcms on mb.level = rcms.level
                where mb.idx = ? and rcms.type =  ? and mb.u_business ='1' ";

        try {
            //$model->transStart();
            $result = $model->db->query($sql, [$member_idx, $type])->getResultArray();

            if (!isset($result) || empty($result)) {
                $logger->info('RewardLoseComps empty');
                $logger->info('RewardLoseComps query' . $model->getLastQuery());
                //$model->db->transRollback();
                return;
            }

            $reward = ($bet_total * $result[0]['myself_lose'] * 0.01);
            $logger->info('RewardLoseComps query' . $model->getLastQuery());
            $logger->info('RewardLoseComps reward : ' . $reward);
            $logger->info('RewardLoseComps bet_total : ' . $bet_total);
            $logger->info('RewardLoseComps myself_lose : ' . $result[0]['myself_lose']);
            if (0 != $reward) {
                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                }

                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['money'],$result[0]['point'],$member_idx,$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $member_idx]);
                }
                //$sql = "update member set point = point + ? where idx = ?";
                

                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                if($type == 'kino_ladder' || $type == 'power_ladder' || $type == 'powerball'){  
                    $type = '미니게임';
                } else if($type == 'virtual_soccer') {
                    $type = '가상게임';
                }

                $a_comment = $type . '(낙첨 배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';
                //$a_comment = '';
                $ukey = md5($member_idx . strtotime('now'));
                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_LOSE_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['point'], $result[0]['point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_LOSE_BACK_REWARD_POINT,0, -$m_money, $result[0]['money'],0, 0, 0, $kind, $a_comment);
                    }
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_LOSE_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['point'], $result[0]['point'] + $reward, $kind, $a_comment);
                }
            }

            if (0 < $result[0]['recommender_lose'] && 0 != $bet_total && 1 == $result[0]['p_u_business']) {
                $reward = ($bet_total * $result[0]['recommender_lose'] * 0.01);
                if (0 == $reward) {
                    //$model->db->transComplete();
                    return;
                }

                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                }

                //$sql = "update member set point = point + ? where idx = ?";
                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['p_money'],$result[0]['p_point'],$result[0]['recommend_member'],$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $result[0]['recommend_member']]);
                }
                


                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                $a_comment = $type . '(추천인 낙첨 배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';

                $ukey = md5($result[0]['recommend_member'] . strtotime('now'));

                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                    $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_LOSE_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['p_point'], $result[0]['p_point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_LOSE_BACK_REWARD_POINT,0,-$m_money,$result[0]['p_money'],0,0,0,$kind,$a_comment);
                    }
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_LOSE_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['p_point'], $result[0]['p_point'] + $reward, $kind, $a_comment);
                }
            }

            //$model->db->transComplete();
        } catch (\mysqli_sql_exception $e) {
            $logger->error(':::::::::::::::  RewardLoseComps error : ' . $e->getMessage());
            $logger->error(':::::::::::::::  RewardLoseComps query : ' . $model->getLastQuery());
            //$model->db->transRollback();
        }
    }

     static public function RewardWinComps($member_idx, $type, $bet_total, $logger, $model) {
        //$memberModel = new MemberModel();
        $logger->info('RewardWinComps start');
        $tLogCashModel = new TLogCashModel();
        $sql = "select mb.money,mb.point,rcms.type,rcms.myself_win ,
                if(parent.u_business <> 1, 0,rcms.recommender_win) as recommender_win,
                mb.recommend_member,
                parent.point as p_point,
                parent.money as p_money,
                parent.u_business as p_u_business
                from member as mb 
                left join member as parent on mb.recommend_member = parent.idx
                left join tb_static_rolling_comps as rcms on mb.level = rcms.level
                where mb.idx = ? and rcms.type =  ? and mb.u_business ='1' ";

        try {
            //$model->transStart();
            $result = $model->db->query($sql, [$member_idx, $type])->getResultArray();

            if (!isset($result) || empty($result)) {
                $logger->info('RewardWinComps empty');
                $logger->info('RewardWinComps query' . $model->getLastQuery());
                //$model->db->transRollback();
                return;
            }

            $reward = ($bet_total * $result[0]['myself_win'] * 0.01);
            $logger->info('RewardWinComps query' . $model->getLastQuery());
            $logger->info('RewardWinComps reward : ' . $reward);
            $logger->info('RewardWinComps bet_total : ' . $bet_total);
            $logger->info('RewardWinComps myself_win : ' . $result[0]['myself_win']);
            if (0 != $reward) {
                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                }

                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['money'],$result[0]['point'],$member_idx,$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $member_idx]);
                }
                //$sql = "update member set point = point + ? where idx = ?";
                

                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                $a_comment = $type . '(당첨 배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';
                //$a_comment = '';
                $ukey = md5($member_idx . strtotime('now'));
                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_WIN_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['point'], $result[0]['point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_WIN_BACK_REWARD_POINT, 0, -$m_money, $result[0]['money'], 0, 0, 0, $kind, $a_comment);
                    }
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $member_idx, USER_BET_WIN_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['point'], $result[0]['point'] + $reward, $kind, $a_comment);
                }
            }

            if (0 < $result[0]['recommender_win'] && 0 != $bet_total && 1 == $result[0]['p_u_business']) {
                $reward = ($bet_total * $result[0]['recommender_win'] * 0.01);
                if (0 == $reward) {
                    //$model->db->transComplete();
                    return;
                }

                if (MAX_PAY_BACK_POINT < $reward) {
                    $reward = MAX_PAY_BACK_POINT;
                } else if ($reward < -MAX_PAY_BACK_POINT) {
                    $reward = -MAX_PAY_BACK_POINT;
                }

                //$sql = "update member set point = point + ? where idx = ?";
                if ($reward < 0) {
                    //$sql = "update member set money = money + ? where idx = ?";
                    list($m_money,$m_point) = UserBettingLose::decPoint($reward,$result[0]['p_money'],$result[0]['p_point'],$result[0]['recommend_member'],$model);
                } else {
                    $sql = "update member set point = point + ? where idx = ?";
                    $model->db->query($sql, [$reward, $result[0]['recommend_member']]);
                }
                


                $start_date = date("Y-m-d", strtotime("-7 day", time()));
                $month = (int) date("m", strtotime("-7 day", time()));

                //$now_week = DateTimeUtil::getWeek($start_date);

                $a_comment = $type . '(추천인 당첨 배팅 ' . $bet_total . '원 / 보상 ' . $reward . '원)';

                $ukey = md5($result[0]['recommend_member'] . strtotime('now'));

                $kind = 'P';
                if ($reward <= 0) {
                    $kind = 'M';
                     $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_WIN_BACK_REWARD_POINT, 0, 0, 0, -$m_point, $result[0]['p_point'], $result[0]['p_point'] - $m_point, $kind, $a_comment);
                    if(0 < $m_money){
                        $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_WIN_BACK_REWARD_POINT,0, -$m_money, $result[0]['p_money'], 0, 0, 0, $kind, $a_comment);
                    }                                    
                } else {
                    $tLogCashModel->insertCashLog_3($ukey, $result[0]['recommend_member'], RECOMMENDER_BET_WIN_BACK_REWARD_POINT, 0, 0, 0, $reward, $result[0]['p_point'], $result[0]['p_point'] + $reward, $kind, $a_comment);
                }
            }

            //$model->db->transComplete();
        } catch (\mysqli_sql_exception $e) {
            $logger->error(':::::::::::::::  RewardWinComps error : ' . $e->getMessage());
            $logger->error(':::::::::::::::  RewardWinComps query : ' . $model->getLastQuery());
            //$model->db->transRollback();
        }
    }
}
