<?php
namespace App\Util;
use CodeIgniter\Log\Logger;
use GuzzleHttp\Client;

class coinTrader {
    private $logger;
    private $http_util;
    private $charge_url = 'test.oxomarket.net';
    private $api_url = 'test.oxomarket.net';
    private $agent = '';
    //private $scope = '';
    private $publicKey = '';
    private $privateKey = '';
    //private $authorization = 'Bearer mF_9.B5f-4.1JqM';
 
    public function __construct($api_url, $charge_url, $agentCode, $publicKey, $privateKey, $logger) {
        $this->api_url = $api_url;
        $this->$charge_url = $charge_url;
        $this->agent = $agentCode;
        $this->publicKey = $publicKey;
        $this->privateKey = $privateKey;
        $this->logger = $logger;
        $this->http_util = new httpUtil();
    }
    
    // 암호화
    private function openssl_encrypt($value){
        //$encryptValue = openssl_encrypt($value, 'aes-256-cbc', $this->privateKey, true, str_repeat(chr(0), 16));
        $encryptValue = base64_encode(openssl_encrypt($value, "AES-256-CBC", $this->privateKey, true, str_repeat(chr(0), 16)));
        return $encryptValue;
    }
    
    public function api_join($userAccount,$userPassword,$userName,$userPhone,$userBank,$userBankaccount){
        /*$userAccount = $this->openssl_encrypt($userAccount);
        $userPassword = $this->openssl_encrypt($userPassword);
        $userName = $this->openssl_encrypt($userName);
        $userPhone = $this->openssl_encrypt($userPhone);
        $userBankaccount = $this->openssl_encrypt($userBankaccount);*/
        
        //$body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount,'userPassword'=>$userPassword,'userName'=> $userName
        //        ,'userPhone'=> $userPhone,'userBank'=>$userBank,'userBankaccount'=> $userBankaccount,'userNameOrigin'=>false));
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount,'userName'=> $userName
                ,'userBank'=>$userBank,'userBankaccount'=> $userBankaccount,'userSafe'=>0));
        
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_join', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 회원조회
    public function api_user($userAccount){
        //$userAccount = $this->openssl_encrypt($userAccount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_user', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));        $result = json_decode($res_result);
        return $result;
    }
    
    // 코인구매
    public function api_deposit($userAccount, $coinAmount){
        $userAccount = $this->openssl_encrypt($userAccount);
        $coinAmount = $this->openssl_encrypt($coinAmount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount,'coinAmount'=>$coinAmount));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_deposit', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 입금계좌 조회
    public function api_bank(){
        $body = json_encode(array('agent'=>$this->agent));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_bank', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 코인전환
    public function api_charge($userAccount, $coinAmount){
        //$userAccount = $this->openssl_encrypt($userAccount);
        //$coinAmount = $this->openssl_encrypt($coinAmount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount,'coinAmount'=>$coinAmount));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_charge', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 잔액조회
    public function api_coin($userAccount){
        //$userAccount = $this->openssl_encrypt($userAccount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_coin', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 회원정보 수정
    public function api_update($userAccount,$userPassword,$userName,$userPhone,$userBank,$userBankaccount){
        $userAccount = $this->openssl_encrypt($userAccount);
        $userPassword = $this->openssl_encrypt($userPassword);
        $userName = $this->openssl_encrypt($userName);
        $userPhone = $this->openssl_encrypt($userPhone);
        $userBankaccount = $this->openssl_encrypt($userBankaccount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount,'userPassword'=>$userPassword,'userName'=> $userName
                ,'userPhone'=> $userPhone,'userBank'=>$userBank,'userBankaccount'=> $userBankaccount,'userNameOrigin'=>false));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_update', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
    
    // 콜백
    public function coinTrans(){
        $userAccount = $this->openssl_encrypt($userAccount);
        
        $body = json_encode(array('agent'=>$this->agent,'userAccount'=>$userAccount));
        $res_result = $this->http_util->curl_post_head_data($this->api_url.'/api_user', $body, array('Content-Type: application/json', 'charset=UTF-8', 'PublicKey:'.$this->publicKey));
        $result = json_decode($res_result);
        return $result;
    }
}