class BettingHistory
{
    constructor()
    {   
        this.product_type_id    = null;
        this.group_id           = 0;
        this.click_item_num     = null;
        this.initializeParameters();
        this.document_ready();
    }

    document_ready()
    {
        $(document).ready(() =>
        {
            this.loadBettingHistory();
            this.loadTabs();
        })
    }

    initializeParameters()
    {
        let url_string              = window.location;
        let url                     = new URL(url_string);
        this.product_type_id        = url.searchParams.get("prd_type");
        this.click_item_num         = url.searchParams.get("clickItemNum");
    }
    loadTabs()
    {
        let param               = {};
        param.product_type_id   = this.product_type_id
        let param_string        = new URLSearchParams(param).toString();

        $.get('/web/betting_history/tabs?' + param_string, (res) =>
        {
            let _tabs           = JSON.parse(res);
            
            var selector = document.querySelector('.select_mini_vleague');
            for(let tab of _tabs)
            {
               
                var newOption = document.createElement('option');
                newOption.value = `${tab.product_group_id}`;
                newOption.text = `${tab.product_group_name}`;
                
                selector.appendChild(newOption);
            }
            console.log(this.click_item_num);
            switch (this.click_item_num) {
                case '10':
                        document.querySelector('.snb5').classList.remove("active");
                        document.querySelector('.snb5').classList.add("active");
                    break;
                case '11':
                        document.querySelector('.snb4').classList.remove("active");
                        document.querySelector('.snb4').classList.add("active");
                    break;
            }
            

            this.addTabEventClick();
        });

    }
    addTabEventClick() {
        var filterMiniGameDataElements = document.querySelectorAll('.filterMiniGameData');
        var self = this;
        var selectorBtn = document.querySelector('.filterMiniGameDataBtn');
        var valueDisplay = document.querySelector('.filterMiniGameData'); 

        filterMiniGameDataElements.forEach(function(element) {
            element.removeEventListener('change', handleChange);
            element.addEventListener('change', handleChange);
        });

        selectorBtn.removeEventListener('click', handleChange);
        selectorBtn.addEventListener('click', handleChange);

        selectorBtn.addEventListener("click", function() {
            valueDisplay.value = "0";
        });

        function handleChange(event) {
            
            self.group_id = this.value; 
         
            self.loadBettingHistory();
        }
    }
    loadBettingHistory(custom_url = null)
    {
        let param               = {};
        param.product_type_id   = this.product_type_id;
        param.product_group_id  = this.group_id;
        let param_string        = new URLSearchParams(param).toString();
        let container           = $(".betting-history-container");



        container.html('');

        $(".betting-history-loading").show();
        $(".betting-history-empty").hide();

        let table_data_url      = '/web/betting_history/table_data?' + param_string;

        if(custom_url)
        {
            table_data_url = custom_url;
        }

        $.get(table_data_url, (res) =>
        {
            let _betting        = JSON.parse(res).betting_history;
            let pagination      = JSON.parse(res).pagination;
            let g_name          = "";

            for(let betting of _betting)
            {

                if (betting.game_name_kr === null) {
                    g_name = betting.gamet_name_en;
                }else{
                    g_name = betting.game_name_kr;
                }

                let betStatus = '대기';
                let betStatusColor = 'bg_gray';
            
                switch(betting.status) {
                    case 'W':
                        betStatus = '적중';
                        betStatusColor = 'bg_blue';
                        break;
                    case 'L':
                        betStatus = '낙첨';
                        betStatusColor = 'bg_red';
                        break;
                    case 'C':
                        betStatus = '취소';
                        betStatusColor = 'bg_yellow';
                        break;
                    case 'I':
                        $betStatus = '인게임보너스';
                        $betStatusColor = 'bg_yellow';
                        break;
                    case 'P':
                        $betStatus = '프로모션보너스';
                        $betStatusColor = 'bg_yellow';
                        break;
                    case 'J':
                        $betStatus = '잭팟보너스';
                        $betStatusColor = 'bg_yellow';
                        break;
                }

                if(this.product_type_id == 2 && betting.status == 'C' && betting.bet_money == betting.take_money) {
                    betStatus = '적중';
                    betStatusColor = 'bg_blue';
                }
            
                if (betting.product_type_id == 1 && betting.status == "C" && betting.bet_money == betting.take_money) {
                    betStatus = "적중";
                    betStatusColor = "bg_blue";
                }

                let append =   '<div class="bet_history_tr">' +
                                    '<div class="bet_history_td">' +  betting.create_dt + '</div>' +
                                    '<div class="bet_history_td" product_group_id="'+  betting.product_group_id +'">' +  betting.product_group_name + '</div>' +
                                    '<div class="bet_history_td">' +  g_name + '</div>' +
                                    '<div class="bet_history_td">' +  betting.bet_money + '</div>' +
                                    '<div class="bet_history_td text-green">' +  betting.take_money + ' 원</div>' +
                                    '<div class="bet_history_td"><span class="' + (betting.status == "W" || betting.status == 1 ? 'sports_division2' : 'sports_division1') + '">' +  betting.result + '</span></div>' +
                                '</div>';
    
                container.append(append);
            }

            $(".betting-history-page").html(pagination);

            this.addPaginationEvent();

            if(!_betting.length)
            {
                $(".betting-history-empty").show();
            }
            else
            {
                $(".betting-history-empty").hide();
            }

            $(".betting-history-loading").hide();
        })
    }
    addPaginationEvent()
    {
        $(".betting-history-page a").unbind("click");
        $(".betting-history-page a").bind("click", (e) =>
        {
            let link = $(e.currentTarget).attr("href");

            if (location.protocol === "https:")
            {
                link = link.replace('http://', 'https://');
            }

            this.loadBettingHistory(link);
            e.preventDefault();
        });
    }
}

