class SlotCasino
{
    constructor(type_id, provider_id, launch_group = false)
    {
        /* initialize used elements */
        this.element_load_all               = ".load_all_slot_casino";
        this.element_game_data_container    = ".slot_game_data_images";
        this.element_game_loader            = ".slot_game_data_loader";
        this.element_game_none              = ".slot_game_data_none";
        this.element_game_launch            = ".launch_game";
        this.element_filter_group           = ".filter_group";
        this.element_launch_group           = ".launch_group";
        this.element_group_container        = "#slot-popup-content";
        this.element_group_container2        = "#slot-popup-content2";
        this.element_group_container3        = "#slot-popup-content3";
        this.element_star_favorite          = ".slot_game_star";
        this.element_tab_container          = ".slot_game_list";
        this.element_gamename_container     = ".slot_game_desc";
        this.element_search_slot            = ".search-slot";
        this.element_search_val            = ".search_slot_input";

        
        


        /* initialize default parameters */
        this.stop_loading_additional        = false;
        this.type_id                        = type_id;
        this.provider_id                    = provider_id;
        this.group_id                       = 0;
        this.group_loded                    = false;
        this.page_loading                   = true;
        this.limit                          = 100;
        this.skip                           = 0;
        this.filter_mode                    = "all";
        this.search_val                    = "";
        this.launch_group                   = launch_group;

        /* routing parameters */

        this.route_enter_game               = '/casino/enter';
        this.route_load_games               = '/web/game-list';
        this.route_load_game_group          = '/web/group-list';
        this.route_add_favorite             = '/game/favorite/add';
        this.route_remove_favorite          = '/game/favorite/remove';
    }
    setElement($keys, $value)
    {
        this['element_' + $keys] = $value;
    }
    initialize()
    {
        $(document).ready(() =>
        {
            this.document_ready();
        })
    }
    document_ready()
    {
        this.loadGameList();
        this.addTabEvents();
    }
    addTabEvents()
    {
        this.updateTabActiveTabs();

        $(this.element_tab_container).find('.tabs').unbind("click");
        $(this.element_tab_container).find('.tabs').bind("click", (e) =>
        {
            this.filter_mode = $(e.currentTarget).attr("mode");
            this.updateTabActiveTabs();
            
            switch (this.filter_mode)
            {
                case "all":
                    this.group_id = 0;
                break;
                case "favorite":
                    this.group_id = 0;
                break;
            }

            this.loadGameList();
            this.updateActiveGroup();
        })

    }
    updateTabActiveTabs()
    {
        $(this.element_tab_container).find('.tabs').each((i, e) =>
        {
            let target = $(e);
            if(target.attr("mode") == this.filter_mode)
            {
                target.addClass("active");
            }
            else
            {
                target.removeClass("active");
            }
        })
    }
    loadGameList(additional_page = false)
    {
        let me              = this;
        this.page_loading   = true;

        if(!additional_page)
        {
            this.skip = 0;
        }
        else
        {
            me.skip = me.skip + me.limit;
        }

        let params  =
        {
            product_type_id     : this.type_id,
            product_group_id    : this.group_id,
            provider_id         : this.provider_id,
            filter_mode         : this.filter_mode,
            search_val          : this.search_val,
            skip                : this.skip,
            limit               : this.limit,
        };

        if((this.stop_loading_additional == false && additional_page == true) || (additional_page == false))
        {
            $(this.element_game_loader).show();
            
            if(this.skip == 0)
            {
                this.stop_loading_additional = false;
            }

            if(!additional_page)
            {
                $(this.element_game_data_container).html('');
            }

            $.ajax(
            {
                type        : "post",
                url         : this.route_load_games,
                data        : params,
                success     : function (response)
                {
                    me.loadGameListElements(response.game_list, additional_page);
                    me.loadGroupListElements(response.group_list);
                    me.searchGames(response.group_list);
                    me.updateTabActiveTabs();
                    me.checkScrollPagination();
                    me.page_loading = false;
                }
            });
        }
    }
    searchGames(group_list){

        let searchTimeout;

        $(this.element_search_val).unbind("keypress");
        $(this.element_search_slot).unbind("click");
    
        $(this.element_search_slot).bind("click", async (e) => {
            e.preventDefault();
            clearTimeout(searchTimeout); 
            this.search_val = $(this.element_search_val).val();
            this.loadGameList();
            searchTimeout = setTimeout(() => {
                searchTimeout = null; 
                $(this.element_load_all).trigger("click");
            }, 100);
        });
    
        $(this.element_search_val).on('keypress', (e) => {
            if (e.which === 13) {
                e.preventDefault();
                clearTimeout(searchTimeout);
                this.search_val = $(this.element_search_val).val();
                this.loadGameList();
                searchTimeout = setTimeout(() => {
                    searchTimeout = null; 
                    $(this.element_load_all).trigger("click");
                }, 100);
            }
        });




    }
    
    loadGroupListElements(group_list) {
        if (!this.group_loaded) {
            this.group_loaded = true;
    
            if (group_list.length > 0) {
                $(this.element_group_container).html('');
    
                let html2Count = 0; 
                let html3Count = 0; 
    
                for (let group of group_list) {
                    this.appendGroupOnHtml(group);
                    
                    if (html2Count < 16) {
                        this.appendGroupOnHtmlForFront(group);
                        html2Count++;
                    }
                    
                    if (html3Count < 9) {
                        this.appendGroupOnHtmlForMobile(group);
                        html3Count++;
                    }
                }
            }
        }
        this.FilterProviderCompany(group_list);
        this.MobileFilterProviderCompany(group_list);
    }
    
    
    loadGameListElements(game_list, additional_page)
    {
        if(game_list.length > 0)
        {
            $(this.element_game_none).hide();

            if(!additional_page)
            {
                $(this.element_game_data_container).html('');
            }
    
            for(let game of game_list)
            {
                if(game['is_use'] == 'OFF' && game['status'] == null) {
                    this.appendGameOnHtml(game);
                }
            }
        }
        else
        {
            if(!additional_page)
            {
                $(this.element_game_data_container).html(``);
                $(this.element_game_none).show();
            }
            else
            {
                this.stop_loading_additional = true;
                $(this.element_game_loader).hide();
            }
        }

        if(game_list.length < this.limit)
        {
            $(this.element_game_loader).hide();
        }
    }
    appendGroupOnHtml(group)
    {
        let append_data     =   `<div class="slot_group_image  ${this.launch_group ? 'launch_group' : 'filter_group'} filter_group" group_id="${group.product_group_id}">
                                    <img src="${group.img_url}">
                                </div>`;
  
        $(this.element_group_container).append(append_data);
        this.addEventFilterGroup();
        this.addEventLaunchGroup();
    }
    appendGroupOnHtmlForFront(group)
    {
        let append_data     =   `<div class="slot-logo-prov-con filter_group  ${this.launch_group ? 'launch_group' : 'filter_group'} filter_group" group_id="${group.product_group_id}">
                                    <img src="${group.img_url}">
                                </div>`;
  
        $(this.element_group_container2).append(append_data);
        this.addEventFilterGroup();
        this.addEventLaunchGroup();
    }
    appendGroupOnHtmlForMobile(group)
    {
        let append_data     =   `<div class="m-slot-logo-prov-con filter_group  ${this.launch_group ? 'launch_group' : 'filter_group'} filter_group" group_id="${group.product_group_id}">
                                    <img src="${group.img_url}">
                                </div>`;
  
        $(this.element_group_container3).append(append_data);
        this.addEventFilterGroup();
        this.addEventLaunchGroup();
    }
    addEventFilterGroup()
    {
        let me = this;

        $(this.element_filter_group).unbind("click");
        $(this.element_filter_group).bind("click", async(e) =>
        {
            this.group_id = $(e.currentTarget).attr("group_id");
            document.getElementById('slot-popup-overlay').style.display = 'none';
            this.filter_mode = "filtered";
            this.updateActiveGroup();
            this.loadGameList();
            this.updateTabActiveTabs();
        });
    }
    addEventLaunchGroup()
    {
        let me = this;

        $(this.element_launch_group).unbind("click");
        $(this.element_launch_group).bind("click", async(e) =>
        {
            let group_id    = $(e.currentTarget).attr("group_id");
            let game_id     = "lobby";

            $(document).find("#loadingCircle").show();
            let launch_url  = await me.getGameURL(game_id, group_id);
            $(document).find("#loadingCircle").hide();
        });
    }
    updateActiveGroup()
    {
        $(this.element_filter_group).each((i, e) =>
        {
            let target      = $(e);
            let group_id    = target.attr("group_id");

            if(this.group_id == 0)
            {target.removeClass("choosed-company");
                target.removeClass("grayscale");
            }
            else if(this.group_id == group_id)
            {
                target.addClass("choosed-company");
                target.removeClass("grayscale");
            }
            else
            {target.removeClass("choosed-company");
                target.addClass("grayscale");
            }
        })
    }
    appendGameOnHtml(game)
    {
        let append_data     =   `<div class="slot_game_image launch_game" popularity="${game.popularity_count}" group_id="${game.product_group_id}" game_id="${game.game_id}">
                                        <div class="img">
                                            <div class="front-img" style="background-image: url('${game.game_image}')" src="${game.game_image}"></div>   
                                        </div>   
                                    <div class="slot_game_desc" game_name="${game.game_name_kr}">${game.game_name_kr}
                                        <div class="slot_game_star ${game.is_favorite == 1 ? 'active' : ''}"><span class="material-symbols-rounded">star</span></div>
                                    </div>
                                </div>`;

        $(this.element_game_data_container).append(append_data);
        this.addEventLaunchGame();
        this.addEventStarFavorite();
    }

    
    addEventStarFavorite()
    {
        $(this.element_star_favorite).unbind("click");
        $(this.element_star_favorite).bind("click", (e) =>
        {
            let target          = $(e.currentTarget);
            let game_id         = target.parents(this.element_game_launch).attr("game_id");
            let game_name       = target.parents(this.element_gamename_container).attr("game_name");
            let url_to_call     = null;
            if(target.hasClass("active"))
            {
                url_to_call     = this.route_remove_favorite;
                target.removeClass("active");
            }
            else
            {
                url_to_call     = this.route_add_favorite;
                target.addClass("active");
            }


            $.post(url_to_call, { game_id: game_id, game_name: game_name });
        })
    }
    addEventLaunchGame()
    {
        let me = this;

        $(this.element_game_launch).find(".img").unbind("click");
        $(this.element_game_launch).find(".img").bind("click", async(e) =>
        {
            let game_id         = $(e.currentTarget).parents(this.element_game_launch).attr("game_id");
            let group_id        = $(e.currentTarget).parents(this.element_game_launch).attr("group_id");
            
            try
            {
                $(document).find("#loadingCircle").show();
                let launch_url      = await me.getGameURL(game_id, group_id);
                if(me.money_checking != true){
                    alert(launch_url);
                } 
                 $(document).find("#loadingCircle").hide();
            }
            catch (error)
            {
                $(document).find("#loadingCircle").hide();
            }
        });
    }
    async getGameURL(game_id, group_id)
    {
        let me = this;

        let params  =
        {
            game_id: game_id,
            provider_id: me.provider_id,
            product_group_id: group_id,
            product_type_id: me.type_id,
        };

        let param_string        = new URLSearchParams(params).toString();
        try {
            let response = await $.ajax({
                type: 'post',
                url: me.route_enter_game,
                data: params,
            });
    
            console.log("Response:", response);
            me.money_checking = true;
            window.open(response.link, "slot_game");
        } catch (err) {
            console.log("Error:", err);
            me.money_checking = false;
            return err.responseJSON.messages.message;
        }
    }
    addModalForProviderFilter()
    {
        const openButton = document.getElementById('open-popup');
        const closeButton = document.getElementById('close-popup');
        const overlay = document.getElementById('slot-popup-overlay');

        openButton.addEventListener('click', function()
        {
            overlay.style.display = 'flex';
        });

        closeButton.addEventListener('click', function()
        {
            overlay.style.display = 'none';
        });
    }
    checkScrollPagination()
    {
        $(window).off('scroll');
        $(window).on('scroll', () =>
        {
            let scroll_top      = $(window).scrollTop();
            let threshold       = $(document).height() * 0.6;

            if(this.page_loading == false && threshold < scroll_top)
            {
                this.loadGameList(true);
            }
        });
    } 
    FilterProviderCompany(group_list){
        const slotLogos = document.querySelectorAll('.slot-logo-prov-con');
        slotLogos.forEach(slotLogo => {
            const groupId = slotLogo.getAttribute('group_id');
            const exists = group_list.some(game => game.product_group_id === groupId);
    
            if (!exists) {
                slotLogo.style.display = 'none';
            } else {
                slotLogo.style.display = 'block'; 
            }
        });
        
        }
        MobileFilterProviderCompany(group_list){
            const slotLogos = document.querySelectorAll('.m-slot-logo-prov-con');
            slotLogos.forEach(slotLogo => {
                const groupId = slotLogo.getAttribute('group_id');
                const exists = group_list.some(game => game.product_group_id === groupId);
                if (!exists) {
                    slotLogo.style.display = 'none';
                } else {
                    slotLogo.style.display = 'block'; 
                }
            });
            
            }

        
}

